// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ADSD AuricularesDobleSalidaDigital
// El archivo dibuja unos auriculares para uso domestico.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente cinco parametros. 
// #macro ADSD_Auriculares( AnguloDerecho, AnguloIzquierdo, AnguloArco,
//                FraccionDerecho, FraccionIzquierdo )  
//      AnguloDerecho           : Angulo de giro, a partir de cero
//              para el auricular derecho.
//      AnguloIzquierdo         : Angulo de giro, a partir de cero
//              para el auricular izquierdo.
//      AnguloArco              : Angulo abarcado por el arco soporte de los
//              auriculares. Utilice un valor entre 90 y 240 grados.  
//      FraccionDerecho         : Fraccion propia para desplazar el auricular 
//              derecho respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//      FraccionIzquierdo       : Fraccion propia para desplazar el auricular 
//              izquierdo respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro ADSD_AuricularesDobleSalidaDigital(
//              AnguloDerecho, AnguloIzquierdo, AnguloArco,
//              FraccionDerecho, FraccionIzquierdo,
//              LongitudArco, ProfundidadArco, GruesoArco,
//              DiametroSpeaker, ProfundidadSpeaker,
//              SeparacionGuiaMetal, LibreMetal, GruesoMetal,
//              TexturaArco, TexturaCuero, TexturaSoporteSpeaker,
//              TexturaMetal, TexturaUnion )
//      AnguloDerecho           : Angulo de giro, a partir de cero
//              para el auricular derecho.
//      AnguloIzquierdo         : Angulo de giro, a partir de cero
//              para el auricular izquierdo.
//      AnguloArco              : Angulo abarcado por el arco soporte de los
//              auriculares. Utilice un valor entre 90 y 240 grados.  
//      FraccionDerecho         : Fraccion propia para desplazar el auricular 
//              derecho respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//      FraccionIzquierdo       : Fraccion propia para desplazar el auricular 
//              izquierdo respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion. 
//      LongitudArco            : Longitud de arco del soporte superior del auricular.
//              Valor por defecto 171*L.
//      ProfundidadArco         : Ancho lateral en Z del arco soporte del auricular.
//              Valor por defecto 11*L.
//      GruesoArco              : Grueso del material de soporte del auricular.
//              Valor por defecto 3.4*L.  
//      DiametroSpeaker         : Diametro referencia para los parlantes.
//              Valor por defecto 53*L.
//      ProfundidadSpeaker      : Referencia para el tamano lateral en X del parlante.
//              Valor por defecto 30*L.               
//      SeparacionGuiaMetal     : Distancia entre los alambritos paralelos para
//              soportar el speaker. Valor por defecto 14*L.
//      LibreMetal              : Referencia para el largo de los alambritos 
//              paralelos para soporte del auricular. Valor por defecto 43*L.
//      GruesoMetal             : Diametro de los alambritos soporte.
//              Valor por defecto 2*L.
//      TexturaArco             : Textura del arco soporte.
//              Valor por defecto ADSD_TexturaArco.
//      TexturaCuero            : Textura del plastico en contacto con la oreja.
//              Valor por defecto ADSD_TexturaCuero.
//      TexturaSoporteSpeaker   : Textura del soporte para el parlante del auricular. 
//              Valor por defecto ADSD_TexturaSoporteSpeaker. 
//      TexturaMetal            : Textura para la guia metalica.
//              Valor por defecto ADSD_TexturaMetal.
//      TexturaUnion            : Textura de union entre el metal y el arco soporte.
//              Valor por defecto ADSD_TexturaUnion.
//
// Con los parametros (30,30,180,0.0,0.0), el auricular se 
// se encuentra completamente contenido en las siguientes coordenadas.
// AuricularesDobleSalidaDigital En 
//      Minimo  = < -  62, -  73, -  29 >*L
//      Maximo  = <    62,    56,    29 >*L   
// Los auriculares son simetricos respecto al plano XY.
// El plano XZ casi separa el arco soporte superior del resto del aparato,
// esta propiedad se conserva al cambiar el valor de los parametros.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ADSD_DefaultTexturaArco             
//      Textura del arco soporte.
// #declare ADSD_DefaultTexturaCuero            
//      Textura del plastico en contacto con la oreja.
// #declare ADSD_DefaultTexturaSoporteSpeaker   
//      Textura del soporte para el parlante del auricular. 
// #declare ADSD_DefaultTexturaMetal            
//      Textura para la guia metalica.
// #declare ADSD_DefaultTexturaUnion            
//      Textura de union entre el metal y el arco soporte.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ADSD_TexturaArco                    = texture  { ... }             
//      Textura del arco soporte.
// #declare ADSD_TexturaCuero                   = texture  { ... }   
//      Textura del plastico en contacto con la oreja.
// #declare ADSD_TexturaSoporteSpeaker          = texture  { ... }
//      Textura del soporte del parlante del auricular. 
// #declare ADSD_TexturaMetal                   = texture  { ... }
//      Textura para la guia metalica.
// #declare ADSD_TexturaUnion                   = texture  { ... }
//      Textura de union entre el metal y el arco soporte.
// #declare ADSD_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "ADSD.inc"
// object        { ADSD_Auriculares( 30, 30, 180, 0.0, 0.0 ) }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "ADSD.inc"   
// object                       {
//   ADSD_AuricularesDobleSalidaDigital( 30, 30, 180, 0.0, 0.0,
//              0.171, 0.011, 0.0034, 0.053, 0.030, 0.014, 0.043, 0.002,      
//        ADSD_TexturaArco, ADSD_TexturaCuero, ADSD_TexturaSoporteSpeaker,
//        ADSD_TexturaMetal, ADSD_TexturaUnion )
// }
//        
// Con modificadores
// #include "ADSD.inc"
// #include "textures.inc"
// #declare ADSD_TexturaArco            = PinkAlabaster
// object        { ADSD_Auriculares( 30, 30, 180, 0.0, 0.0 ) }
//            


#declare ADSD_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( ADSD_POV3_1 )
    #declare ADSD_POV3_1        = on;
  #end
#else
  #ifndef( ADSD_POV3_1 )
    #declare ADSD_POV3_1        = off;
  #end
#end

#declare ADSD_DefaultTexturaArco        =
  texture                               {
    pigment                             {
      Gray20
    }
    normal                              {
      granite
      scale                     0.001
    }
  }

#ifndef ( ADSD_TexturaArco )
  #declare ADSD_TexturaArco             = ADSD_DefaultTexturaArco
#end  // #ifndef ( ADSD_TexturaArco )

#declare ADSD_DefaultTexturaCuero       =
  texture                               {
    pigment                             {
      Gray15
    }
    normal                              {
      radial
      frequency                 20
      rotate                    90*x
      rotate                    90*y
    }
  }

#ifndef ( ADSD_TexturaCuero )
  #declare ADSD_TexturaCuero            = ADSD_DefaultTexturaCuero
#end  // #ifndef ( ADSD_TexturaCuero )

#declare ADSD_DefaultTexturaSoporteSpeaker      =
  texture                               {
    pigment                             {
      Gray70
    }
    normal                              {
      onion
      frequency                 5
    }
  }

#ifndef ( ADSD_TexturaSoporteSpeaker )
  #declare ADSD_TexturaSoporteSpeaker   = ADSD_DefaultTexturaSoporteSpeaker
#end  // #ifndef ( ADSD_TexturaSoporteSpeaker )

#declare ADSD_DefaultTexturaMetal       =
  texture                               {
    pigment                             {
      Silver
    }
    normal                              {
      gradient y
      turbulence        1       
      sine_wave
      scale             0.01
    }
  }

#ifndef ( ADSD_TexturaMetal )
  #declare ADSD_TexturaMetal            = ADSD_DefaultTexturaMetal
#end  // #ifndef ( ADSD_TexturaMetal )

#declare ADSD_DefaultTexturaUnion       =
  texture                               {
    pigment                             {
      Gray30
    }
    normal                              {
      agate
      scale                     0.1
    }
    finish                              {
      metallic
    }
  }

#ifndef ( ADSD_TexturaUnion )
  #declare ADSD_TexturaUnion            = ADSD_DefaultTexturaUnion
#end  // #ifndef ( ADSD_TexturaUnion )


#macro ADSD_Orejas( AnguloDerecho
        DiametroSpeaker, ProfundidadSpeaker,
        SeparacionGuiaMetal, LibreMetal, GruesoMetal,
        TexturaCuero, TexturaSoporteSpeaker, TexturaMetal )
  union                                 {
    #local DiametroInterno              = 24/53*DiametroSpeaker;
    #local ExcesoDecorativo             =  5/53*DiametroSpeaker;
    #local TamanoXNegativo              = ProfundidadSpeaker-
                ( DiametroSpeaker-DiametroInterno )/2;
    #local CruceGuiaY                   =
                sqrt( DiametroSpeaker*DiametroSpeaker-
                        SeparacionGuiaMetal*SeparacionGuiaMetal )/2;
    union                               {
      union                               {
        difference                          {
          torus                             {
            ( DiametroSpeaker+DiametroInterno )/4,
            ( DiametroSpeaker-DiametroInterno )/4
            rotate                          90*x
            rotate                          90*y
          }
          plane                             {
            x, 0
          }
          texture                           {
            TexturaCuero
          }
        }
        torus                               {
          DiametroSpeaker/2, ExcesoDecorativo/2
          rotate                            90*x
          rotate                            90*y
          translate                         -ExcesoDecorativo/2*x
          texture                           {
            TexturaCuero
            rotate                          5
          }
        }
        union                               {
          difference                        {
            sphere                          {
              0, 1
              scale                 < TamanoXNegativo,
                                      DiametroSpeaker/2, DiametroSpeaker/2 >
            }
            plane                           {
              -x, 0
            }
          }
          torus                             {
            DiametroSpeaker/4, ExcesoDecorativo/2
            rotate                          90*x
            rotate                          90*y
            translate       ( -TamanoXNegativo+3*ExcesoDecorativo/4 )*x
          }
          texture                           {
            TexturaSoporteSpeaker
          }
        }
        translate                 3*ExcesoDecorativo*x/2
        rotate                    -AnguloDerecho*z
      }
      union                               {
        cylinder                            {
          -DiametroSpeaker/2*z, +DiametroSpeaker/2*z,
          GruesoMetal/2
        }
        sphere                            {
          -DiametroSpeaker/2*z, GruesoMetal/2
        }
        sphere                            {
          +DiametroSpeaker/2*z, GruesoMetal/2
        }
        sphere                            {
          -SeparacionGuiaMetal/2*z, GruesoMetal/2
          translate                       +CruceGuiaY*y
        }
        sphere                            {
          +SeparacionGuiaMetal/2*z, GruesoMetal/2
          translate                       +CruceGuiaY*y
        }
        difference                        {
          torus                             {
            DiametroSpeaker/2, GruesoMetal/2
            rotate                          90*x
            rotate                          90*y
          }
          plane                           {
            y, 0
          }
          box                             {
            < -GruesoMetal, 0, -SeparacionGuiaMetal/2 >,
            < +GruesoMetal, +DiametroSpeaker,
              +SeparacionGuiaMetal/2 >
          }
        }
        texture                           {
          TexturaMetal
        }
      }
      translate                         -CruceGuiaY*y
      rotate                            30*z
    }
    union                               {
      cylinder                          {
        0, LibreMetal*y, GruesoMetal/2
        translate                       -SeparacionGuiaMetal/2*z
      }
      sphere                            {
        < 0, LibreMetal, -SeparacionGuiaMetal/2 >, GruesoMetal/2
      }
      sphere                            {
        < 0, LibreMetal, +SeparacionGuiaMetal/2 >, GruesoMetal/2
      }
      cylinder                          {
        0, LibreMetal*y, GruesoMetal/2
        translate                       +SeparacionGuiaMetal/2*z
      }
      difference                        {
        torus                           {
          SeparacionGuiaMetal/2, GruesoMetal/2
          rotate                        90*x
          rotate                        90*y
        }
        plane                           {
          y, 0
        }
        rotate                          30*z
        translate                       LibreMetal*y
      }
      texture                           {
        TexturaMetal
      }
    }
    translate                           -0.5*LibreMetal*y
  }
#end  // #macro ADSD_Orejas()

#macro ADSD_AuricularesDobleSalidaDigital(
                AnguloDerecho, AnguloIzquierdo, AnguloArco,
                FraccionDerecho, FraccionIzquierdo,
                LongitudArco, ProfundidadArco, GruesoArco,
                DiametroSpeaker, ProfundidadSpeaker,
                SeparacionGuiaMetal, LibreMetal, GruesoMetal,
                TexturaArco, TexturaCuero, TexturaSoporteSpeaker,
                TexturaMetal, TexturaUnion )
  union                                 {
    #local RadioArco                    =
                LongitudArco*180/( pi*AnguloArco );
    #local AnguloAjusteArcoD            = ( AnguloArco-180 )/2;
    #local AjusteYArco                  =
                RadioArco*sin( radians( AnguloAjusteArcoD ) );
    #local MaxUnion                   =
          max( ProfundidadArco, SeparacionGuiaMetal/2+2*GruesoMetal );
    #local MinUnion                   =
          max( 1.05*ProfundidadArco/2, SeparacionGuiaMetal/2+2*GruesoMetal );
    #local UnionArcoMetal               =
      difference                        {
        prism                              {
          cubic_spline
          -3*GruesoMetal/2, 3*GruesoArco/2,
          9,
          < +MaxUnion, 0 >,
          < -MaxUnion, 0 >,
          < -MinUnion, -0.25*LibreMetal >,
          < -( MaxUnion+MinUnion )/2, -0.40*LibreMetal >,
          < +( MaxUnion+MinUnion )/2, -0.40*LibreMetal >,
          < +MinUnion, -0.25*LibreMetal >,
          < +MaxUnion, 0 >,
          < -MaxUnion, 0 >,
          < -MinUnion, -0.3*LibreMetal >
          rotate                  -90*x
          rotate                  -90*y
        }
        superellipsoid                  {
          <0.6,0.6>
          scale         11*MinUnion/24
          translate                     -MinUnion*x/2-0.45*LibreMetal/2*y
        }
        texture                         {
          TexturaUnion
        }
      }
    // Arco
    difference                          {
      cylinder                          {
        -ProfundidadArco/2*z, +ProfundidadArco/2*z,
        RadioArco+GruesoArco/2
      }
      cylinder                          {
        -ProfundidadArco*z, +ProfundidadArco*z,
        RadioArco-GruesoArco/2
      }
      box                               {
        < -2*RadioArco, 0, -ProfundidadArco >,
        <  0, -2*RadioArco, +ProfundidadArco >
        rotate                          AnguloAjusteArcoD*z
      }
      box                               {
        < -2*RadioArco, -0.5*RadioArco, -ProfundidadArco >,
        <  0.5*RadioArco, -2*RadioArco, +ProfundidadArco >
        rotate                          AnguloAjusteArcoD*z
      }
      box                               {
        < +2*RadioArco, 0, -ProfundidadArco >,
        <  0, -2*RadioArco, +ProfundidadArco >
        rotate                          -AnguloAjusteArcoD*z
      }
      box                               {
        < +2*RadioArco, -0.5*RadioArco, -ProfundidadArco >,
        < -0.5*RadioArco, -2*RadioArco, +ProfundidadArco >
        rotate                          -AnguloAjusteArcoD*z
      }
      translate                         AjusteYArco*y
      texture                           {
        TexturaArco
      }
    }
    union                               {
      object                            {
        ADSD_Orejas( AnguloDerecho, DiametroSpeaker, ProfundidadSpeaker,
                   SeparacionGuiaMetal, LibreMetal, GruesoMetal,
                   TexturaCuero, TexturaSoporteSpeaker, TexturaMetal )
        translate     -0.95*FraccionDerecho*LibreMetal/2*y
      }
      object                            {
        UnionArcoMetal
      }
      translate           -( RadioArco+GruesoArco/2+GruesoMetal/2 )*x
      rotate                            +AnguloAjusteArcoD*z
      translate                         AjusteYArco*y
    }
    union                               {
      object                            {
        ADSD_Orejas( AnguloIzquierdo, DiametroSpeaker, ProfundidadSpeaker,
                   SeparacionGuiaMetal, LibreMetal, GruesoMetal,
                   TexturaCuero, TexturaSoporteSpeaker, TexturaMetal )
        scale                           <-1, 1, 1>
        translate     -0.95*FraccionIzquierdo*LibreMetal/2*y
      }
      object                            {
        UnionArcoMetal
        scale                   <-1,1,1>
      }
      translate           +( RadioArco+GruesoArco/2+GruesoMetal/2 )*x
      rotate                            -AnguloAjusteArcoD*z
      translate                         AjusteYArco*y
    }
  }
#end  // #macro ADSD_AuricularesDobleSalidaDigital()

#macro ADSD_Auriculares( AnguloDerecho, AnguloIzquierdo, AnguloArco,
                FraccionDerecho, FraccionIzquierdo )
  object                                {
    #local L                            = ADSD_L;
    #local LongitudArco                 = 171*L;
    #local ProfundidadArco              =  11*L;
    #local GruesoArco                   =   3.4*L;
    #local DiametroSpeaker              =  53*L;
    #local ProfundidadSpeaker           =  30*L;
    #local SeparacionGuiaMetal          =  14*L;
    #local LibreMetal                   =  43*L;
    #local GruesoMetal                  =   2*L;
    ADSD_AuricularesDobleSalidaDigital(
        AnguloDerecho, AnguloIzquierdo, AnguloArco,
        FraccionDerecho, FraccionIzquierdo,
        LongitudArco, ProfundidadArco, GruesoArco,
        DiametroSpeaker, ProfundidadSpeaker,
        SeparacionGuiaMetal, LibreMetal, GruesoMetal,
        ADSD_TexturaArco, ADSD_TexturaCuero, ADSD_TexturaSoporteSpeaker,
        ADSD_TexturaMetal, ADSD_TexturaUnion )
  }
#end  // #macro ADSD_Auriculares()

