// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// ADSD AuricularesDobleSalidaDigital
// El archivo dibuja unos auriculares para uso domestico.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente cinco parametros. 
// #macro ADSD_Auriculares( AnguloDerecho, AnguloIzquierdo, AnguloArco,
//                FraccionDerecho, FraccionIzquierdo )  
//      AnguloDerecho           : Angulo de giro, a partir de cero
//              para el auricular derecho.
//      AnguloIzquierdo         : Angulo de giro, a partir de cero
//              para el auricular izquierdo.
//      AnguloArco              : Angulo abarcado por el arco soporte de los
//              auriculares. Utilice un valor entre 90 y 240 grados.  
//      FraccionDerecho         : Fraccion propia para desplazar el auricular 
//              derecho respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//      FraccionIzquierdo       : Fraccion propia para desplazar el auricular 
//              izquierdo respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro ADSD_AuricularesDobleSalidaDigital(
//              AnguloDerecho, AnguloIzquierdo, AnguloArco,
//              FraccionDerecho, FraccionIzquierdo,
//              LongitudArco, ProfundidadArco, GruesoArco,
//              DiametroSpeaker, ProfundidadSpeaker,
//              SeparacionGuiaMetal, LibreMetal, GruesoMetal,
//              TexturaArco, TexturaCuero, TexturaSoporteSpeaker,
//              TexturaMetal, TexturaUnion )
//      AnguloDerecho           : Angulo de giro, a partir de cero
//              para el auricular derecho.
//      AnguloIzquierdo         : Angulo de giro, a partir de cero
//              para el auricular izquierdo.
//      AnguloArco              : Angulo abarcado por el arco soporte de los
//              auriculares. Utilice un valor entre 90 y 240 grados.  
//      FraccionDerecho         : Fraccion propia para desplazar el auricular 
//              derecho respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion.
//      FraccionIzquierdo       : Fraccion propia para desplazar el auricular 
//              izquierdo respecto de su guia metalica. 
//              Utilice 0.0 para minima contraccion. 
//      LongitudArco            : Longitud de arco del soporte superior del auricular.
//              Valor por defecto 171*L.
//      ProfundidadArco         : Ancho lateral en Z del arco soporte del auricular.
//              Valor por defecto 11*L.
//      GruesoArco              : Grueso del material de soporte del auricular.
//              Valor por defecto 3.4*L.  
//      DiametroSpeaker         : Diametro referencia para los parlantes.
//              Valor por defecto 53*L.
//      ProfundidadSpeaker      : Referencia para el tamano lateral en X del parlante.
//              Valor por defecto 30*L.               
//      SeparacionGuiaMetal     : Distancia entre los alambritos paralelos para
//              soportar el speaker. Valor por defecto 14*L.
//      LibreMetal              : Referencia para el largo de los alambritos 
//              paralelos para soporte del auricular. Valor por defecto 43*L.
//      GruesoMetal             : Diametro de los alambritos soporte.
//              Valor por defecto 2*L.
//      TexturaArco             : Textura del arco soporte.
//              Valor por defecto ADSD_TexturaArco.
//      TexturaCuero            : Textura del plastico en contacto con la oreja.
//              Valor por defecto ADSD_TexturaCuero.
//      TexturaSoporteSpeaker   : Textura del soporte para el parlante del auricular. 
//              Valor por defecto ADSD_TexturaSoporteSpeaker. 
//      TexturaMetal            : Textura para la guia metalica.
//              Valor por defecto ADSD_TexturaMetal.
//      TexturaUnion            : Textura de union entre el metal y el arco soporte.
//              Valor por defecto ADSD_TexturaUnion.
//
// Con los parametros (30,30,180,0.0,0.0), el auricular se 
// se encuentra completamente contenido en las siguientes coordenadas.
// AuricularesDobleSalidaDigital En 
//      Minimo  = < -  62, -  73, -  29 >*L
//      Maximo  = <    62,    56,    29 >*L   
// Los auriculares son simetricos respecto al plano XY.
// El plano XZ casi separa el arco soporte superior del resto del aparato,
// esta propiedad se conserva al cambiar el valor de los parametros.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare ADSD_DefaultTexturaArco             
//      Textura del arco soporte.
// #declare ADSD_DefaultTexturaCuero            
//      Textura del plastico en contacto con la oreja.
// #declare ADSD_DefaultTexturaSoporteSpeaker   
//      Textura del soporte para el parlante del auricular. 
// #declare ADSD_DefaultTexturaMetal            
//      Textura para la guia metalica.
// #declare ADSD_DefaultTexturaUnion            
//      Textura de union entre el metal y el arco soporte.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare ADSD_TexturaArco                    = texture  { ... }             
//      Textura del arco soporte.
// #declare ADSD_TexturaCuero                   = texture  { ... }   
//      Textura del plastico en contacto con la oreja.
// #declare ADSD_TexturaSoporteSpeaker          = texture  { ... }
//      Textura del soporte del parlante del auricular. 
// #declare ADSD_TexturaMetal                   = texture  { ... }
//      Textura para la guia metalica.
// #declare ADSD_TexturaUnion                   = texture  { ... }
//      Textura de union entre el metal y el arco soporte.
// #declare ADSD_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "ADSD.inc"
// object        { ADSD_Auriculares( 30, 30, 180, 0.0, 0.0 ) }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "ADSD.inc"   
// object                       {
//   ADSD_AuricularesDobleSalidaDigital( 30, 30, 180, 0.0, 0.0,
//              0.171, 0.011, 0.0034, 0.053, 0.030, 0.014, 0.043, 0.002,      
//        ADSD_TexturaArco, ADSD_TexturaCuero, ADSD_TexturaSoporteSpeaker,
//        ADSD_TexturaMetal, ADSD_TexturaUnion )
// }
//        
// Con modificadores
// #include "ADSD.inc"
// #include "textures.inc"
// #declare ADSD_TexturaArco            = PinkAlabaster
// object        { ADSD_Auriculares( 30, 30, 180, 0.0, 0.0 ) }
//            

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-500  ,-500   , -3000 >*L
         White
}
background      {
         Gray50
}    
#include "ADSD.inc"

#declare FactorAcercamiento     = 10;    
    
object                  {
  ADSD_Auriculares( 30, 30, 180, 0.0, 0.0 )    
  translate             +0.010*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}





