// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  17 marzo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//
// BEUT BicicletaEstacionariaUnTripulante
// El archivo dibuja una bicicleta estacionaria.
// Es muy poco flexible, pero incluye una macro para modificar 
// unas pocas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente tres parametros  
// #macro BEUT_BicicletaEstacionaria( GirarPedal, GirarPedalDerecho, GirarPedalIzquierdo )  
//      GirarPedal              : Angulo para girar los pedales.
//      GirarPedalDerecho       : Gira el pedal derecho al tripulante sobre su eje.
//      GirarPedalIzquierdo     : Gira el pedal izquierdo al tripulante sobre su eje.        
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro BEUT_BicicletaEstacionariaUnTripulante( GirarPedal,  
//                GirarPedalDerecho, GirarPedalIzquierdo,
//                FactorXAsiento, FactorYAsiento,
//                FactorXManivela, FactorYManivela,  
//                TexturaMetalBrillante, TexturaMetalBurdo,  
//                TexturaCuero, TexturaProtectora,  
//                TexturaMetalBrillanteOscuro, TexturaPedal )
//      GirarPedal              : Angulo para girar los pedales.
//      GirarPedalDerecho       : Gira el pedal derecho al tripulante sobre su eje.
//      GirarPedalIzquierdo     : Gira el pedal izquierdo al tripulante sobre su eje. 
//      FactorXAsiento          : Fraccion para reubicar en X el asiento.
//              Valor 1.0 por defecto.
//      FactorYAsiento          : Fraccion para reubicar en Y el asiento.
//              Valor 1.0 por defecto.
//      FactorXManivela         : Fraccion para reubicar en X la manivela.
//              Valor 1.0 por defecto.
//      FactorYManivela         : Fraccion para reubicar en Y la manivela.
//              Valor 1.0 por defecto.  
//      TexturaMetalBrillante   : Textura de algunas zonas metalizadas (manivela y asiento).
//              Valor BEUT_TexturaMetalBrillante por defecto.
//      TexturaMetalBurdo       : Textura de metal de soporte.
//              Valor BEUT_TexturaMEtalBurdo por defecto.
//      TexturaCuero            : Textura del cuero artificial.
//              Valor BEUT_TexturaCuero por defecto.
//      TexturaProtectora       : Textura del plastico resistente protector de cadena y piso.
//              Valor BEUT_TexturaProtectora por defecto.
//      TexturaMetalBrillanteOscuro             : Textura de algunas zonas metalizadas
//              de menor resistencia (medidor y cadena).
//              Valor BEUT_TexturaMetalBrillanteOscuro por defecto.
//      TexturaPedal            : Textura de los pedales.
//              Valor BEUT_TexturaPedal por defecto.
//                                                  
// La bicicleta se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-190,   0, -190 >*L
//      Maximo  = < 250, 590,  190 >*L
// Frente hacia X+, el eje de giro del pedal en Y.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BEUT_DefaultTexturaMetalBrillante   
//      Textura de algunas zonas metalizadas (manivela y asiento).
// #declare BEUT_DefaultTexturaMetalBurdo       
//      Textura de metal de soporte.
// #declare BEUT_DefaultTexturaCuero            
//      Textura del cuero artificial.
// #declare BEUT_DefaultTexturaProtectora       
//      Textura del plastico resistente protector de cadena y piso.
// #declare BEUT_DefaultTexturaMetalBrillanteOscuro             
//      Textura de algunas zonas metalizadas de menor resistencia (medidor y cadena).
// #declare BEUT_DefaultTexturaPedal            
//      Textura de los pedales.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BEUT_ColorAguja                             = Red;
//      Color de la aguja indicadora en el medidor.
// #declare BEUT_TexturaMetalBrillante                  = texture { ... }   
//      Textura de algunas zonas metalizadas (manivela y asiento).
// #declare BEUT_TexturaMetalBurdo                      = texture { ... }
//      Textura de metal de soporte.
// #declare BEUT_TexturaCuero                           = texture { ... }
//      Textura del cuero artificial.
// #declare BEUT_TexturaProtectora                      = texture { ... }
//      Textura del plastico resistente protector de cadena y piso.
// #declare BEUT_TexturaMetalBrillanteOscuro            = texture { ... } 
//      Textura de algunas zonas metalizadas de menor resistencia (medidor y cadena).
// #declare BEUT_TexturaPedal                           = texture { ... }
//      Textura de los pedales.
// #declare BEUT_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "BEUT.inc"
// object        { BEUT_BicicletaEstacionaria( 0, 0, 0 ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "BEUT.inc"   
// object        { BEUT_BicicletaEstacionariaUnTripulante( 0, 0, 0, 1, 1, 1, 1,  
//                 BEUT_TexturaMetalBrillante, BEUT_TexturaMetalBurdo,  
//                 BEUT_TexturaCuero, BEUT_TexturaProtectora,  
//                 BEUT_TexturaMetalBrillanteOscuro, BEUT_TexturaPedal ) }
//         
// Con modificadores
// #include "BEUT.inc"
// #include "textures.inc"
// #declare BEUT_TexturaMetalBrillante   = PinkAlabaster
// object        { BEUT_BicicletaEstacionaria( 0, 0, 0 ) }
//

#include "colors.inc" 
#include "BEUT.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "BEUT.inc"
                              
#local FactorAcercamiento               = 2.0;                              

object                          { 
  BEUT_BicicletaEstacionaria( 0, 20, 30 )
  translate             -0.295*y      
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
} 
