// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  16 junio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// BPNP BrujulaParaNoPerderse
// El archivo dibuja una brujula de campamento corriente.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene cinco parametros. Al asignar los parametros es importante
// considerar que el gancho bloquea el movimiento de la tapa, y esta bloquea el libre
// movimiento de la lupa.  
// #macro BPNP_Brujula( AnguloAbrir, AnguloLupa, AnguloGancho,
//                RotarDorado, Rotar3DEscala )
//      AnguloAbrir             : Angulo para abrir la tapa. Cero es cerrada.
//      AnguloLupa              : Angulo para mover la lupa. Cero es cerrada.
//      AnguloGancho            : Angulo para mover el gancho. Cero es cerrado.
//      RotarDorado             : Permite rotar el borde dorado de la brujula.
//              Para acomodar las marcas verdes en el plastico transparente.
//      Rotar3DEscala           : Rota como vector el plano con escalas.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro BPNP_BrujulaParaNoPerderse( AnguloAbrir, AnguloLupa, AnguloGancho,
//                RotarDorado, Rotar3DEscala,
//                AltoBase, DiametroBase, GruesoPlastico, AltoDorado,
//                AltoTapa, DiametroLupa, DiametroGancho, GruesoPelo,
//                TexturaPrincipal, TexturaDorada,
//                TexturaInterna, TexturaVidrio )
//      AnguloAbrir             : Angulo para abrir la tapa. Cero es cerrada.
//      AnguloLupa              : Angulo para mover la lupa. Cero es cerrada.
//      AnguloGancho            : Angulo para mover el gancho. Cero es cerrada.
//      RotarDorado             : Permite rotar el borde dorado de la brujula.
//              Esto permite acomodar las marcas verdes en el plastico transparente.
//      Rotar3DEscala           : Rota como vector el plano con escalas.
//      AltoBase                : Alto de la base inferior de la brujula.
//              Valor por defecto 10.70*L.
//      DiametroBase            : Diametro de la base inferior de la brujula.
//              Valor por defecto 40.00*L.
//      GruesoPlastico          : Grueso para las paredes plasticas.
//              Valor por defecto 1.90*L.
//      AltoDorado              : Alto del anillo dorado para orientar las marcas.
//              Valor por defecto 2.45*L.
//      AltoTapa                : Alto de la tapa.
//              Valor por defecto 8.20*L.
//      DiametroLupa            : Diametro de la lupa.
//              Valor por defecto 16.25*L.
//      DiametroGancho          : Diametro del alambre de la agarradera.
//              Valor por defecto 1.30*L.
//      GruesoPelo              : Grueso del alambrito guia en la tapa.
//              Valor por defecto 0.20*L.
//      TexturaPrincipal        : Textura principal de la brujula.
//              Valor por defecto BPNP_TexturaPrincipal.
//      TexturaDorada           : Textura decorativa de bordes y metal.
//              Valor por defecto BPNP_TexturaDorada.
//      TexturaInterna         : Textura del interna de la brujula.
//              Valor por defecto BPNP_TexturaInterna.
//      TexturaVidrio           : Textura transparente para proteccion de las escalas. 
//              Valor por defecto BPNP_TexturaVidrio.
//
// La brujula cerrada se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <- 26,   0, - 22 >*L
//      Maximo  = <  28,  23,   22 >*L  
// Caratula mira hacia Y+, con la tapa hacia X-, Norte hacia Z-.
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare BPNP_DefaultTexturaPrincipal  
//      Textura principal de la brujula.
// #declare BPNP_DefaultTexturaDorada      
//      Textura decorativa bordes y metal.
// #declare BPNP_DefaultTexturaInterna           
//      Textura interna de la brujula.
// #declare BPNP_DefaultTexturaVidrio       
//      Textura plastica transparente para proteger las escalas.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare BPNP_TexturaPrincipal               = texture { ... }                 
//      Textura principal de la brujula.
// #declare BPNP_TexturaDorada                  = texture { ... }
//      Textura decorativa bordes y metal.                                   
// #declare BPNP_TexturaInterna                 = texture { ... }
//      Textura interna de la brujula.
// #declare BPNP_TexturaVidrio                  = texture { ... }   
//      Textura plastica transparente para proteger las escalas.      
// #declare BPNP_GIFCaratura                    = "BPNP_IM1.gif"
//      Imagen para las escalas de la brujula.
// #declare BPNP_ColorBarritaGuia               = Green;
//      Color de la barrita guia en la cubierta transparente.
// #declare BPNP_ColorBarritaNegra              = Black;     
//      Color de las marcas negras de algunas direcciones.
//
// Para colocarlo simplemente
// #include "BPNP.inc"
// object        { BPNP_Brujula( 0, 0, 0, 0, <0,0,0> ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "BPNP.inc"   
// object                       {
//   BPNP_BrujulaParaNoPerderse( 0, 0, 0, 0, <0,0,0>,
//              0.01070, 0.04000, 0.00190, 0.00245,
//              0.00820, 0.01625, 0.00130, 0.00020,
//              BPNP_TexturaPrincipal, BPNP_TexturaDorada,
//              BPNP_TexturaInterna, BPNP_TexturaVidrio )
// }
//        
// Con modificadores
// #include "BPNP.inc"
// #include "textures.inc"
// #declare BPNP_TexturaPrincipal   = PinkAlabaster
// object        { BPNP_Brujula( 0, 0, 0, 0, <0,0,0> ) }
// 
  
#declare BPNP_POV3_1                = on;
// Problemas al ejecutar macro 
  
#include "BPNP_AU1.inc"
#include "colors.inc"
#include "woods.inc"
#include "textures.inc"

#declare BPNP_L                 = 0.001;

#declare BPNP_ColorBarritaGuia          = Green;
#declare BPNP_ColorBarritaNegra         = Black;  
#declare BPNP_GIFCaratula               = "BPNP_IM1.gif"

#declare BPNP_DefaultTexturaPrincipal      =
  texture                       {
     pigment                    {
       Brown*0.1
     }
     rotate             90*x
  }          
  texture                       {
  pigment                       {    
    bumps       
    turbulence          1 
    scale               0.01
    pigment_map                 {  
      [ 0.0  Black ]
      [ 0.5  Brown transmit 0.8 ]
      [ 0.75 Clear ]
    }
  }                              
  }

#ifndef ( BPNP_TexturaPrincipal )
  #declare BPNP_TexturaPrincipal           = BPNP_DefaultTexturaPrincipal
#end  // #ifndef ( BPNP_TexturaPrincipal )

#declare BPNP_DefaultTexturaDorada      =
  texture                               {
    pigment                             {
      Gold
    }
  }

#ifndef ( BPNP_TexturaDorada )
  #declare BPNP_TexturaDorada           = BPNP_DefaultTexturaDorada
#end  // #ifndef ( BPNP_TexturaDorada )

#declare BPNP_DefaultTexturaInterna     =
  texture                               {
    pigment                             {
      White
    }
  }

#ifndef ( BPNP_TexturaInterna )
  #declare BPNP_TexturaInterna          = BPNP_DefaultTexturaInterna
#end  // #ifndef ( BPNP_TexturaDorada )

#declare BPNP_DefaultTexturaVidrio      =
  texture                               {
    Glass3
  }

#ifndef ( BPNP_TexturaVidrio )
  #declare BPNP_TexturaVidrio           = BPNP_DefaultTexturaVidrio
#end  // #ifndef ( BPNP_TexturaVidrio )

#macro BPNP_BrujulaParaNoPerderse( AnguloAbrir, AnguloLupa, AnguloGancho,
                RotarDorado, Rotar3DEscala,
                AltoBase, DiametroBase, GruesoPlastico, AltoDorado,
                AltoTapa, DiametroLupa, DiametroGancho, GruesoPelo,
                TexturaPrincipal, TexturaDorada,
                TexturaInterna, TexturaVidrio )
  union                                 {        
    #declare BPNP_POV3_1                = on;
    // Problemas en el codigo, requieren la simulacion
    // Capsula Negra Inferior
    #local AnchoSoporte                 = 18.7*AltoBase/10.7;
    union                               {
      difference                        {
        cylinder                        {
          0, AltoBase*y, DiametroBase/2
        }
        cylinder                        {
          AltoBase*y/2, 1.1*AltoBase*y, DiametroBase/2-GruesoPlastico
        }
      }  // Pared por diferencia
    }
    // Bloque Interno
    union                               {
      // Escala Movil
      cylinder                             {
        #local BordeMovil               = DiametroBase/4-4*GruesoPlastico;
        0, -GruesoPlastico/10*y, 1
        pigment                       {
          image_map                   {
            gif BPNP_GIFCaratula
          }
          rotate                90*x
          translate             -0.5
          scale                 2
        }
        scale               ( DiametroBase/4+BordeMovil )*<1,0,1>+y
        rotate                          Rotar3DEscala
        translate                       3*AltoBase/4*y
      }
      // Elementos Fijos
      union                             {
        // Eje Dorado
        union                           {
          difference                    {
            cylinder                    {
              AltoBase*y, AltoBase/2*y, GruesoPlastico
            }
            cylinder                    {
              1.1*AltoBase*y, 0, 3*GruesoPlastico/4
            }
          }
          difference                    {
            cylinder                    {
              AltoBase*y, AltoBase/2*y, GruesoPlastico/2
            }
            cylinder                    {
              1.1*AltoBase*y, 0, GruesoPlastico/4
            }
          }
          texture                       {
            TexturaDorada
          }
        }
        // Bloque Blanco soporte interno
        difference                      {
          cylinder                        {
            AltoBase*y/2, AltoBase*y,
            DiametroBase/2-2*GruesoPlastico
          }
          cylinder                        {
            1.1*AltoBase*y/2, ( AltoBase+AltoDorado )*y,
                  DiametroBase/2-3*GruesoPlastico
          }
          texture                       {
            TexturaInterna
          }
        }
        // Vidrio Interno
        union                           {
          cylinder                        {
            0, +AltoDorado/8*y, DiametroBase/2-2*GruesoPlastico
            translate             AltoBase*y
          }
          intersection                    {
            cylinder                        {
              0, +1.01*AltoDorado/8*y, DiametroBase/2-2*GruesoPlastico
              translate         AltoBase*y
            }
            cylinder                      {
              -2*GruesoPlastico*x, -( DiametroBase/2-3*GruesoPlastico )*x,
              GruesoPlastico/8
              translate         ( AltoBase+AltoDorado/8 )*y
            }
            pigment                       {
              BPNP_ColorBarritaNegra
            }
          }
          texture                       {
            TexturaVidrio
          }
        }  // VidrioInterno
      }
    }
    union                               {
      // Anillo dorado interno
      union                             {
        difference                        {
          cylinder                        {
            AltoBase*y/2, ( AltoBase+AltoDorado )*y, DiametroBase/2-GruesoPlastico
          }
          cylinder                        {
            1.01*AltoBase*y/2, ( AltoBase+2*AltoDorado )*y,
                  DiametroBase/2-3*GruesoPlastico/2
          }
          #local C                        = 0;
          #local TotalRelieve             =
              int( 4*pi*( DiametroBase/2-GruesoPlastico )/GruesoPlastico );
          #while ( C < TotalRelieve )
            cylinder                      {
              0, AltoDorado*y, GruesoPlastico/8
              translate             AltoBase*y-( DiametroBase/2-GruesoPlastico )*z
              rotate                     360*C/TotalRelieve*y
            }
            #local C                      = C+1;
          #end  // #while ( C < 1 )
          texture                         {
            TexturaDorada
          }
        }
        // Vidrio Superior
        union                             {
          cylinder                        {
            0, -GruesoPlastico/4*y, DiametroBase/2-3*GruesoPlastico/2
            translate             ( AltoBase+0.99*AltoDorado )*y
          }
          intersection                    {
            cylinder                        {
              0, -GruesoPlastico/8*y, DiametroBase/2-3*GruesoPlastico/2
              translate             ( AltoBase+AltoDorado )*y
            }
            union                         {
              cylinder                      {
                1*GruesoPlastico*z, ( DiametroBase-2*GruesoPlastico )*z,
                GruesoPlastico/4
              }
              cylinder                      {
                ( DiametroBase/2-2*GruesoPlastico )*z/2,
                ( DiametroBase-2*GruesoPlastico )*z,
                GruesoPlastico/4
                rotate            45*y
              }
              translate             ( AltoBase+0.99*AltoDorado )*y
            }
            pigment                       {
              BPNP_ColorBarritaGuia
            }
          }
          texture                         {
            TexturaVidrio
          }
        }
        rotate                          RotarDorado*y
      }
    }
    // Soporte Cubierta
    difference                          {
      union                               {
        #local Hundir                     = 0.5*( DiametroBase-
          sqrt( DiametroBase*DiametroBase-AnchoSoporte*AnchoSoporte ) );
        difference                        {
          cylinder                        {
            -AnchoSoporte/2*z, AnchoSoporte/2*z, 0.8*AltoBase
          }
          plane                           {
            -x, 0
          }
          plane                           {
            -y, 0
          }
          cylinder                        {
            -AltoBase*y, AltoBase*y, DiametroBase/2
            translate             ( DiametroBase/2-Hundir )*x
          }
        }
        cylinder                        {
          -AnchoSoporte/2*z, AnchoSoporte/2*z, 0.2*AltoBase
          translate             -0.6*AltoBase*x
        }
      }
      cylinder                          {
        -1.05*3*AnchoSoporte/8*z, 1.05*3*AnchoSoporte/8*z, 0.4*AltoBase
        translate             -0.6*AltoBase*x
      }
      translate                         AltoBase*y-DiametroBase/2*x
      translate                         Hundir*x
    }  // SoporteCubierta
    // Tapa
    union                               {
      // Tapa propiamente
      union                             {
        // Alambrito
        cylinder                        {
          -9*DiametroBase/20*x, +9*DiametroBase/20*x, GruesoPelo/2
          translate     ( AltoTapa-GruesoPlastico/2 )*y
          texture                       {
            TexturaDorada
          }
        }
        // Diferencia principal Tapa
        difference                      {
          union                         {
            cylinder                    {
              0, AltoTapa*y, DiametroBase/2
            }
            cylinder                    {
              0, ( AltoDorado+GruesoPlastico )*y,
              DiametroBase/2+GruesoPlastico
            }
            box                           {
              < -2.05*DiametroBase/6, AltoTapa/2,
                -1.05*DiametroBase/10 >,
              < +2.05*DiametroBase/6, AltoTapa+GruesoPlastico/4,
                +1.05*DiametroBase/10 >
            }
          }
          union                         {
            cylinder                    {
              0, ( AltoTapa-GruesoPlastico )*y, DiametroBase/2-GruesoPlastico
            }
            cylinder                    {
              -AltoDorado*y, AltoDorado*y,
              DiametroBase/2
            }
            
          }
          box                           {
            < -2*DiametroBase/6, 0, -DiametroBase/10 >,
            < +2*DiametroBase/6, AltoTapa+2*GruesoPlastico, +DiametroBase/10 >
          }
        } // Diferencia principal Tapa
      }  // Tapa propiamente
      // Cilindros de giro
      union                             {
        cylinder                          {
          -3*AnchoSoporte/8*z, 3*AnchoSoporte/8*z, 0.2*AltoBase
        }
        cylinder                          {
          -3*AnchoSoporte/8*z, 3*AnchoSoporte/8*z, 0.2*AltoBase
          translate             0.4*AltoBase*y
        }
        difference                        {
          union                           {
            box                             {
              < 0, 0, -3*AnchoSoporte/8 >,
              < AnchoSoporte, 0.6*AltoBase, +3*AnchoSoporte/8 >
            }
            box                             {
              < -0.2*AltoBase, 0, -3*AnchoSoporte/8 >,
              < 0, 0.4*AltoBase, +3*AnchoSoporte/8 >
            }
          }
          cylinder                        {
            -AltoBase*y, AltoBase*y, DiametroBase/2
            translate             ( DiametroBase/2+0.6*AltoBase-Hundir )*x
          }
        }
        translate                         ( -DiametroBase/2
                                                +Hundir-0.6*AltoBase )*x
      }
      translate                         ( +DiametroBase/2
                                          -Hundir+0.6*AltoBase )*x
      rotate                            AnguloAbrir*z
      translate                         AltoBase*y-DiametroBase/2*x
      translate                         ( Hundir-0.6*AltoBase )*x
    }
    // Lupa
    union                               {
      sphere                            {
        0, 1
        scale                           0.99*DiametroLupa/3*<1,0,1>+GruesoPlastico/4*y
        translate                       ( AltoBase/2+3*AltoDorado/2+GruesoPlastico/2 )*y
        texture                         { TexturaVidrio }
      }
      difference                        {
        union                           {
          cylinder                      {
            0, GruesoPlastico/2*y, DiametroLupa/2
          }
          cylinder                      {
            0, GruesoPlastico*y, DiametroLupa/3
          }
          box                           {
            < 0, 0, -DiametroLupa/3 >,
            < DiametroBase/2+GruesoPlastico, GruesoPlastico/2, DiametroLupa/3 >
          }
          difference                    {
            union                       {
              box                           {
                < DiametroLupa/2, 0, -2*DiametroLupa/9 >,
                < DiametroBase/2+GruesoPlastico, 3*GruesoPlastico/4, +2*DiametroLupa/9 >
              }
              box                           {
                < DiametroBase/2+GruesoPlastico/2, -AltoBase/2-3*AltoDorado/2, -2*DiametroLupa/9 >,
                < DiametroBase/2+5*GruesoPlastico/4, 3*GruesoPlastico/4, +2*DiametroLupa/9 >
              }
            }
            box                           {
              < DiametroLupa/4, -AltoBase, -DiametroLupa/6 >,
              < DiametroBase/2+2*GruesoPlastico, GruesoPlastico, +DiametroLupa/6 >
            }
          }
          box                           {
            < DiametroBase/2+GruesoPlastico/2, GruesoPlastico/2, -DiametroLupa/3 >,
            < DiametroBase/2+GruesoPlastico  , -AltoBase/2-3*AltoDorado/2, DiametroLupa/3 >
          }
          box                           {
            < DiametroBase/2+GruesoPlastico/2, -AltoBase/2-3*AltoDorado/2, -DiametroLupa/3 >,
            < DiametroBase/2+AltoBase/2, -AltoBase/2-3*AltoDorado/2+GruesoPlastico/2, +DiametroLupa/3 >
          }
        }
        cylinder                        {
          -GruesoPlastico*y, 2*GruesoPlastico*y, DiametroLupa/4
        }
        box                               {
          <-DiametroLupa  , -GruesoPlastico, -GruesoPlastico/8 >,
          <-DiametroLupa/3, AltoBase, GruesoPlastico/8 >
        }
        translate                       ( AltoBase/2+3*AltoDorado/2 )*y
      }
      cylinder                          {
        -DiametroLupa/4*z, DiametroLupa/4*z, GruesoPlastico/2
        translate               ( DiametroBase+AltoBase )*x/2
      }
      translate                         ( -DiametroBase/2
                                          -AltoBase/2 )*x
      rotate                            -AnguloLupa*z
      translate                         AltoBase*y/2+DiametroBase/2*x
      translate                         ( AltoBase/2 )*x
    }
    // Soporte Lupa
    union                               {
      difference                        {
        union                           {
          box                           {
            < 0, 0.1*AltoBase, -DiametroLupa/2 >
            < DiametroBase/2+AltoBase/4, 0.9*AltoBase,
              +DiametroLupa/2 >
          }
          box                           {
            < 0, 0.1*AltoBase, -5*DiametroLupa/12 >
            < DiametroBase/2+AltoBase/2+3*GruesoPlastico/2, 0.9*AltoBase,
              +5*DiametroLupa/12 >
          }
        }
        cylinder                        {
          0, AltoBase*y, DiametroBase/2
        }
        box                           {
          < 0, 0, -DiametroLupa/3 >
          < DiametroBase/2+AltoBase/2+GruesoPlastico/2, AltoBase,
            +DiametroLupa/3 >
        }
      }
    }  // SoporteLupa
    // Gancho Metal
    union                               {
      #local ArregloGancho              = array [ 5 ]
        { -DiametroLupa*z/2,
                     -1.1*DiametroLupa*z/2+( AltoBase/2+AltoTapa+AltoDorado+DiametroGancho/2 )*y,
                     -DiametroBase/2*x+( AltoBase/2+AltoTapa+AltoDorado+DiametroGancho/2 )*y,
                     +1.1*DiametroLupa*z/2+( AltoBase/2+AltoTapa+AltoDorado+DiametroGancho/2 )*y,
                     +DiametroLupa*z/2 } 
      cylinder                          {  
        -DiametroLupa*z/2, +DiametroLupa*z/2, DiametroGancho/3
      }               
      object                            {
        BPNP_SweepBezierAbierto( ArregloGancho, DiametroGancho/2, 1.0 )
      }
      rotate                           -AnguloGancho*z
      translate                         AltoBase/2*y
                +( DiametroBase/2+AltoBase/2 )*x
      texture                           {
        TexturaDorada
      }
    }
    texture                             {
      TexturaPrincipal
    }
  }
#end  // #macro BPNP_BrujulaParaNoPerderse

#macro BPNP_Brujula( AnguloAbrir, AnguloLupa, AnguloGancho,
                RotarDorado, Rotar3DEscala )
  object                        {
    #local L                    = BPNP_L;
    #local AltoBase             = 10.70*L;
    #local DiametroBase         = 40.00*L;
    #local GruesoPlastico       =  1.90*L;
    #local AltoDorado           =  2.45*L;
    #local AltoTapa             =  8.20*L;
    #local DiametroLupa         = 16.25*L;
    #local DiametroGancho       =  1.30*L;
    #local GruesoPelo           =  0.20*L;
    BPNP_BrujulaParaNoPerderse( AnguloAbrir, AnguloLupa, AnguloGancho,
        RotarDorado, Rotar3DEscala,
        AltoBase, DiametroBase, GruesoPlastico, AltoDorado,
        AltoTapa, DiametroLupa, DiametroGancho, GruesoPelo,
        BPNP_TexturaPrincipal, BPNP_TexturaDorada,
        BPNP_TexturaInterna, BPNP_TexturaVidrio )
  }
#end  // #macro BPNP_Martillo
