// This file is licensed under the terms of the CC-LGPL. 
//
// NOTA: Las llantas del vehiculo son obra de F.Dispot
// donadas a la biblioteca POVRay (administrada por Misha Riser) 
// para su libre uso (inclusive comercial por defecto) el 26 junio 2001
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 28 octubre 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas
// definido como 0.001 para POVRAY
//                      
// CVTF CarroVehicularTetraFord
// El archivo dibuja un carro poco flexible. El archivo,
// permite redefinir las texturas, abrir las ventanas, abrir las puertas y girar las ruedas.
// Un alto porcentaje del modelo fue disenado mediante la herramienta Epspline.exe,
// para prismas. 
// El interesado puede conseguir el programa Epspline.exe en 
// htp://agalena.nfshost.com/b1/ 
//      
// La siguiente macro dibuja el objeto default: 
// #macro CVTF_Carro()    
//                                             
// La siguiente macro permite mover algunos elementos:                               
// #macro CVTF_CarroVehicularTetraFord(   
//            GiroPuertaDelanteraDerecha , GiroPuertaDelanteraIzquierda  ,  
//            GiroPuertaPosteriorDerecha , GiroPuertaPosteriorIzquierda  ,     
//            GiroRuedasDelanteras       , AnguloRodar                   ,
//            FraccionAbrirVentanaDerecha, FraccionAbrirVentanaIzquierda )  
//      GiroPuertaDelanteraDerecha          : Angulo positivo para abrir la puerta
//          delantera derecha del conductor.
//      GiroPuertaDelanteraIzquierda        : Angulo positivo para abrir la puerta
//          delantera izquierda del conductor.
//      GiroPuertaPosteriorDerecha          : Angulo positivo para abrir la puerta
//          posterior a la derecha del conductor.
//      GiroPuertaPosteriorIzquierda        : Angulo positivo para abrir la puerta
//          posterior a la izquierda del conductor.   
//      GiroRuedasDelanteras                : Angulo de giro paralelo al eje Y,
//          de las ruedas delanteras. Para movimiento curvo.
//      AnguloRodar                         : Angulo para rotar las cuatro ruedas
//          sobre si mismas.
//      FraccionAbrirVentanaDerecha         : Fraccion propia para abrir la Ventana
//          a la derecha del conductor.
//      FraccionAbrirVentanaIzquierda       : Fraccion propia para abrir la ventana
//          a la izquierda del conductor.
//  
//                                                        
// Las dimensiones del objeto default son :  
//      Minimo                  : <-1620,    0,- 670>*L
//      Maximo                  : <+1625,  885,+ 670>*L  
// El frente del carro en direccion X-. Se encuentra parcialmente
// centrado sobre el plano XZ, gravedad Y-.
// 
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse.
// CVTF_DefaultTexturaPrincipal
//      Textura principal del carro
// CVTF_DefaultTexturaProtector    
//      Textura de los parachoques
// CVTF_DefaultTexturaBrazo       
//      Textura de los brazos interiores a la puerta
// CVTF_DefaultTexturaRespaldar                     
//      Textura del respaldar de los asientos
// CVTF_DefaultTexturaManivela               
//      Textura de las manivelas
// CVTF_DefaultTexturaBajos     
//      Textura de las zonas bajas
// CVTF_DefaultTexturaBombillo    
//      Textura del vidrio de las luces
// CVTF_DefeaultTexturaFondoBombillo
//      Textura de fondo de las luces delanteras   
// CVTF_DefaultTexturaFondoBombilloPosterior
//      Textura de fondo de las luces posteriores
// CVTF_DefaultMaterialVidrio
//      Material de las ventanas del carro
//   
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare CVTF_TexturaPrincipal               = CVTF_DefaultTexturaPrincipal
//      Textura principal del carro
// #declare CVTF_TexturaProtector               = CVTF_DefaultTexturaProtector    
//      Textura de los parachoques
// #declare CVTF_TexturaBrazo                   = CVTF_DefaultTexturaBrazo       
//      Textura de los brazos interiores a la puerta
// #declare CVTF_TexturaRespaldar               = CVTF_DefaultTexturaRespaldar                     
//      Textura del respaldar de los asientos
// #declare CVTF_TexturaManivela                = CVTF_DefaultTexturaManivela               
//      Textura de las manivelas
// #declare CVTF_TexturaBajos                   = CVTF_DefaultTexturaBajos     
//      Textura de las zonas bajas
// #declare CVTF_TexturaBombillo                = CVTF_DefaultTexturaBombillo    
//      Textura del vidrio de las luces
// #declare CVTF_TexturaFondoBombillo           = CVTF_DefaultTexturaFondoBombillo
//      Textura de fondo de las luces delanteras   
// #declare CVTF_TexturaFondoBombilloPosterior  = CVTF_DefaultTexturaFondoBombilloPosterior
//      Textura de fondo de las luces posteriores
// #declare CVTF_MaterialVidrio                 = CVTF_DefaultMaterialVidrio
//      Material de las ventanas del carro
// #declare CVTF_ImagenPlaca                            = "CVTF_IM2.jpg"
//      Imagen para la placa del carro.           
// #declare CVTF_ManivelaDerechaIzquierda               = false;
//      "true" ubica la manivela a la derecha del conductor. Si "false" a la izquierda.
//
// Para colocarlo simplemente
//
// #include "CVTF.inc"
//  object                  {
//    CVTF_Carro( ) 
//  }
//
//  o bien la misma figura con la macro detallada... 
//  #include "CVTF.inc"
//  object                  { 
//    CVTF_CarroVehicularTetraFord(0,0,0,0,0,0,0,0)  
//  }
//
//  o bien se puede redefinir alguna textura 
//  #include "CVTF.inc"                            
//  #include "textures.inc"
//  #declare CVTF_TexturaPrincipal = PinkAlabaster 
//  object                  {                                   
//    CVTF_Carro()
//  }
// 
#include "colors.inc"
      
#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "CVTF.inc"
#declare FactorAcercamiento         = 0.5; 
                       
object                  {
  CVTF_Carro()       
  translate         -0.4425*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z                     
} 
                          

 





