// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  19 mayo 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// CDTC CocinaDiscoTransferenciaCalor
// El archivo dibuja una cocina de uso domestico electrica.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente un parametro  
// #macro CDTC_Cocina( AnguloPuerta )   
//      AnguloPuerta            : Angulo para abrir la puerta del horno.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro CDTC_CocinaDiscoTransferenciaCalor( AnguloPuerta, AnguloPerillas
//                FrenteFundamental, AltoFundamental, ProfundidadFundamental,
//                AltoHorno, LateralHorno, BaseHorno, AltoBotones,
//                ProfundidadPuerta, AltoSuperior, ProfundidadSuperior,
//                SeparacionDiscos, DiametroDiscos, ArregloTexturas )
//      AnguloPuerta            : Angulo para abrir la puerta del horno.
//      AnguloPerillas          : array [5] de angulos en grados para girar las perillas
//              numeradas de izquierda a derecha, vistas desde el frente.
//              Por defecto su valor es CDTC_PerillasApagadas, todas en 0.
//      FrenteFundamental       : Frente del horno. Valor por defecto 365*L.
//      AltoFundamental         : Referencia para el alto del horno.
//              Valor por defecto 636*L.
//      ProfundidadFundamental  : Referencia para la profundidad del horno.
//              Valor por defecto 330*L.
//      AltoHorno               : Referencia para el tamano de abertura del horno.
//              Valor por defecto 272*L.
//      LateralHorno            : Referencia para el grueso de las paredes laterales
//              internas del horno. Valor por defecto 38*L.
//      BaseHorno               : Referencia para el grosor inferior desde la base
//              para ubicar el horno. Valor por defecto 250*L.
//      AltoBotones             : Alto en Y para el panel de botones.
//              Valor por defecto 71*L.
//      ProfundidadPuerta       : Referencia para el grosor de la puerta.
//              Valor por defecto 32*L.
//      AltoSuperior            : Referencia para el alto del panel superior de la cocina.
//              Valor por defecto 21*L.
//      ProfundidadSuperior     : Referencia para la profundidad Z del panel superior.
//              Valor por defecto 372*L.
//      SeparacionDiscos        : Separacion centro a centro entre discos.
//              Valor por defecto 164*L.
//      DiametroDiscos          : Diametro de los discos de calentamiento.
//              Valor por defecto 114*L.     
//      ArregloTexturas         : array [ 7 ] de texturas, en el siguiente orden:
//              { TexturaPrincipal, TexturaHorno, TexturaMetal, 
//                TexturaDiscos, TexturaVentanaHorno, TexturaPerilla, TexturaSuperior }.
//              Por defecto tienen asignado los siguientes valores:
//              { CDTC_TexturaPrincipal, CDTC_TexturaHorno, CDTC_TexturaMetal,
//                CDTC_TexturaDiscos, CDTC_TexturaVentanaHorno, 
//                CDTC_TexturaPerilla, CDTC_TexturaSuperior }     
//                      TexturaPrincipal        : Textura principal del aparato.
//                      TexturaHorno            : Se aplica al horno   
//                      TexturaMetal            : Partes metalizadas
//                      TexturaDiscos           : Discos de calentamiento   
//                      TexturaVentanaHorno     : Ventanilla del horno
//                      TexturaPerilla          : Perillas de ajuste
//                      TexturaSuperior         : Panel de exposicion   
//
// La cocina se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-183,   0, -390 >*L
//      Maximo  = < 183, 810,   55 >*L
// Frente hacia Z-, gravedad hacia Y-. Piso en plano XZ.
// El plano XY sirve de base a la estructura principal, pero el panel
// superior sobresale en Z+.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare CDTC_DefaultTexturaPrincipal  
//      Textura principal del aparato.
// #declare CDTC_DefaultTexturaHorno       
//      Textura del horno.
// #declare CDTC_DefaultTexturaMetal            
//      Textura de partes metalizadas.
// #declare CDTC_DefaultTexturaDiscos       
//      Textura de los discos de calentamiento.
// #declare CDTC_DefaultTexturaVentanaHorno
//      Textura ventanilla del horno.
// #declare CDTC_DefaultTexturaPerilla             
//      Textura de las perillas de control.   
// #declare CDTC_DefaultTexturaSuperior            
//      Textura del panel superior.  
// #declare CDTC_PerillasApagadas               = array [ 5 ] { 0,0,0,0,0 }
//      Perillas por defecto, todas en posicion off. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare CDTC_TexturaPrincipal               = texture { ... }                 
//      Textura principal del aparato.
// #declare CDTC_TexturaHorno                   = texture { ... }
//      Textura del horno.                                   
// #declare CDTC_TexturaMetal                   = texture { ... }
//      Textura de partes metalizadas.
// #declare CDTC_TexturaDiscos                  = texture { ... }   
//      Textura de los discos de calentamiento.                     
// #declare CDTC_TexturaVentanaHorno            = texture { ... }
//      Textura ventanilla del horno.
// #declare CDTC_TexturaPerilla                 = texture { ... }
//      Textura de las perillas de control.
// #declare CDTC_TexturaSuperior                = texture { ... }
//      Textura del panel superior.                               
// #declare CDTC_POV3_1                                 = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "CDTC.inc"
// object        { CDTC_Cocina( 0 ) }
//                           
// Ejemplo con la macro detallada, mismo objeto default
// #include "CDTC.inc"   
// #local ArregloTexturas            = array [ 7 ]
//                { CDTC_TexturaPrincipal, CDTC_TexturaHorno,
//                  CDTC_TexturaMetal, CDTC_TexturaDiscos,
//                  CDTC_TexturaVentanaHorno, CDTC_TexturaPerilla,
//                  CDTC_TexturaSuperior }         
// object                       {
//   CDTC_CocinaDiscoTransferenciaCalor( 0, CDTC_PerillasApagadas,
//              0.365, 0.636, 0.330, 0.272, 0.038, 0.250, 0.071,
//              0.032, 0.021, 0.372, 0.164, 0.114, ArregloTexturas )
// }
//        
// Con modificadores
// #include "CDTC.inc"
// #include "textures.inc"
// #declare CDTC_TexturaPrincipal   = PinkAlabaster
// object        { CDTC_Cocina( 0 ) }
//

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         


light_source    {
         < 500  , 500   , -3000 >*L
         White
}        


background      {
         Gray50
}    

#include "CDTC.inc"
                                   
#local FactorAcercamiento       = 1.5;                                   
                                   

object                          {
  CDTC_Cocina( 0 )
  translate             -0.375*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}
