// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 25 agosto 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// CGCU ColadorGravitacionalCocinaUnico
// El archivo dibuja un colador corriente.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro CGCU_Colador()    
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro CGCU_ColadorGravitacionalCocinaUnico(
//                DiametroFundamental, DiametroInterior, FactorHondo,
//                ProfundidadBorde, GruesoPlastico,
//                HilerasRed, FactorAire,
//                LargoBrazo, AnchoBrazo, ProfundidadBrazo,
//                TexturaPrincipal, TexturaRed )
//      DiametroFundamental     : Diametro del circulo exterior del anillo soporte.
//              Valor por defecto 107*L.
//      DiametroInterior        : Diametro del circulo interior (aire) del anillo soporte.
//              Valor por defecto 102*L.
//      FactorHondo             : La red no es una esfera sino un elipsoide comprimido
//              segun <1,1,FactorHondo>. Valor por defecto 7/7.5.
//      ProfundidadBorde        : Profundidad Z del borde de la red.
//              Valor por defecto 14*L.
//      GruesoPlastico          : Grueso principal del plastico.
//              Valor por defecto 2*L.
//      HilerasRed              : Total de hileras en la Red. Misma cantidad
//              en ambos sentidos. Valor por defecto 100.
//      FactorAire              : Fraccion propia para determinar el grueso 
//              y separacion de los hilos de la red. Valores cercanos a uno produce
//              una red mas fina, cercanos a cero producen filos mas gruesos con
//              poca separacion. Valor por defecto 0.8.    
//      LargoBrazo              : Referencia para longitud Y del mango.
//              Valor por defecto 99*L.
//      AnchoBrazo              : Referencia para el ancho X del brazo.
//              Valor por defecto 35*L.
//      ProfundidadBrazo        : Profundidad Z del brazo.
//              Valor por defecto 5*L.   
//      TexturaPrincipal        : Textura principal del colador.
//              Valor por defecto CGCU_TexturaPrincipal.
//      TexturaRed              : Textura de la red.
//              Valor por defecto CGCU_TexturaRed.
//
// El colador
// se encuentra completamente contenid0 en las siguientes coordenadas.
//      Minimo  = < - 54, -153, - 44 >*L
//      Maximo  = < + 54,   54,    0 >*L   
// El centro del elipsoide virtual se encuentra en el origen. La red hacia Z-, el mango
// hacia Y-. El objeto descansa sobre el plano XY. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare CGCU_DefaultTexturaPrincipal        
//      Textura principal del colador.
// #declare CGCU_DefaultTexturaRed            
//      Textura de la red.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare CGCU_TexturaPrincipal               = texture { ... }        
//      Textura principal del colador.
// #declare CGCU_TexturaRed                     = texture { ... }
//      Textura de la red.
// #declare CGCU_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "CGCU.inc"
// object        { CGCU_Colador( ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "CGCU.inc"   
// object                       {
//   CGCU_ColadorGravitacionalCocinaUnico( 0.107,  0.102, 
//              7/7.5, 0.014, 0.002,
//              100, 0.8, 0.099, 0.035, 0.005,
//              CGCU_TexturaPrincipal, CGCU_TexturaRed )
// }
//        
// Con modificadores
// #include "CGCU.inc"
// #include "textures.inc"
// #declare CGCU_TexturaPrincipal   = PinkAlabaster  
// object        { CGCU_Colador( ) }
//

// #if ( version >= 3.7 )
  #version 3.7;
// #end

// POVRay 3.7 solicita declarar la version
// en el primer renglon ejecutable
// Podria ser util eliminar o agregar la doble barra de comentario
global_settings                         {
  assumed_gamma                 1.0
}

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;    
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         

light_source    {
         < 500  , 500   , -3000 >*L
         White
} 
light_source    {
         <-300  ,-300   , -3000 >*L
         White
}

background      {
         Gray50
}    

#include "CGCU.inc"

#local FactorAcercamiento       = 8;

object                  {
  CGCU_Colador()
  rotate                90*z     
  translate             -0.05*x
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}





