// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// HFCJ HeightFieldCorazonJesus
// El archivo dibuja una imagen en bajorelieve de yeso
// del Corazon de Jesus
// Se utilizo una tecnica de doble foto para generar
// un HeigthField
//
// El dibujo puede generarse con la siguiente macro.
// #macro HFCJ_HeightFieldCorazonJesus()
//
// Caracteristicas del objeto:
//      Alto            = 289*L
//      Ancho           = 213*L
//      Profundidad     =  50*L
// El objeto descansa sobre el plano XZ gravedad Y-.
// El marco centrado respecto al eje Z.
// El frente sobresale hacia Z- y descansa sobre el plano XY.
//
// Para colocarlo simplemente
// #include "HFCJ.inc"
// object        { HFCJ_HeightFieldCorazonJesus() }
//

#include "woods.inc"


#declare HFCJ_L                 = 0.001;

#if ( version < 3.2 )
  #ifndef( HFCJ_POV3_1 )
    #declare HFCJ_POV3_1        = on;
  #end
#else
  #ifndef( HFCJ_POV3_1 )
    #declare HFCJ_POV3_1        = off;
  #end
#end

#macro HFCJ_HeightField()
  height_field          {
    gif         "HFCJ_IM1.gif"
    water_level         0.01
    smooth
    hierarchy           on
    rotate              -90*x
    pigment             {
      image_map         {
        gif     "HFCJ_IM2.gif"
      }
      translate       -0.5*x-0.5*y
      scale           1.025
      translate       +0.5*x+0.5*y
    } 
    finish              { 
      ambient           0.4 
      #if ( HFCJ_POV3_1 )     
        diffuse         0.2
      #else  // #else ( HFCJ_POV3_1 )
        diffuse albedo  0.2 
      #end   // #else ( HFCJ_POV3_1 )
    }
    normal              {
      bumps
    }
    translate           -0.525*x-0.5*y
    rotate              -1*z
    scale               <1.4,1,0.3>
    translate           +0.5*y-0.01*z+0.045*x 
    rotate              2*z
    scale               1/4
  }
#end  // #macro HFCJ_HeigthField

#macro HFCJ_HeightFieldCorazonJesus( )
  union                 {
    object              {
      HFCJ_HeightField()
      scale             4
      translate           -0.5*y
    }
    union               {
      box                 {
        <-0.425,-0.50,-0.2>,
        <+0.425,-0.45, 0.00>
      }
      texture           {
        T_Wood31
      }
    }
    union               {
      box               {
        <-0.425,-0.45,-0.02>,
        <+0.425,+0.25, 0.00>
      }
      difference        {
        prism             {
          cubic_spline
          0, 0.02,7
          <+0.425,+0.25>,
          <+0.00,-0.15>,
          <-0.425,+0.25>,
          <+0.00,+0.65>,
          <+0.425,+0.25>,
          <+0.00,-0.15>,
          <-0.425,+0.25>
          rotate  -90*x
        }
        cylinder                {
          -z, z, 0.020
          translate     +0.60*y
        }
      }
      union             {
        torus           {
          0.02,0.0025
          rotate        -90*x
          translate     +0.60*y-0.02*z
        }
        pigment         {
          Silver
        }
        normal        {
          bumps
          scale       0.01
        }
      }
      texture           {
        T_Wood25
      }
    }
    translate           +0.5*y
    scale               1/4
  }
#end  // #macro HFCJ_HeightFieldCorazonJesus
