// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 19 marzo 2013
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// HFCJ HeightFieldCorazonJesus
// El archivo dibuja una imagen en bajorelieve de yeso
// del Corazon de Jesus
// Se utilizo una tecnica de doble foto para generar
// un HeigthField
//
// El dibujo puede generarse con la siguiente macro.
// #macro HFCJ_HeightFieldCorazonJesus()
//
// Caracteristicas del objeto:
//      Alto            = 289*L
//      Ancho           = 213*L
//      Profundidad     =  50*L
// El objeto descansa sobre el plano XZ gravedad Y-.
// El marco centrado respecto al eje Z.
// El frente sobresale hacia Z- y descansa sobre el plano XY.
//
// Para colocarlo simplemente
// #include "HFCJ.inc"
// object        { HFCJ_HeightFieldCorazonJesus() }
//
#if ( version >= 3.7 ) 
#version 3.7;
#end         
// POVRay 3.7 solicita el numero de version en el primer renglon ejecutable.
// En el futuro podria ser necesario eliminar el comentario #if ... #end   
global_settings                         {
  assumed_gamma                         1.0
}
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
light_source    {
         <-2000  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    
#include "HFCJ.inc"

#local FactorAcercamiento       = 4;

object                  {
  HFCJ_HeightFieldCorazonJesus()   
  translate     -0.14*y
  translate       -( VecesCentroAbsoluto+1 )
         *( FactorAcercamiento-1 )/( FactorAcercamiento )*OjoAbsoluto*L*z   
}
