// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  7 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// EGPP EnGrapadoraParaPapel
// El archivo dibuja una engrapadora corriente.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene dos parametros. 
// #macro EGPP_EnGrapadora( AnguloBoca, AnguloMetal )    
//      AnguloBoca              : Angulo para abrir la boca del aparato.
//              Utilice valores negativos para presionar.
//      AnguloMetal             : Gira el bloque de grapas respecto de la boca.
//              Valores negativos para giro hacia abajo.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro EGPP_EnGrapadoraParaPapel( AnguloBoca, AnguloMetal,
//          LargoFundamental, AnchoFundamental, AltoBase,
//          LargoSuperior, AnchoSuperior, AltoSuperior,
//          EjeDesplazado, EjeAlto, DiametroEje, GruesoMetal,
//          TexturaPrincipal, TexturaMetal, TexturaMetalFijo,
//          TexturaSuperior, TexturaPlastico )
//      AnguloBoca              : Angulo para abrir la boca del aparato.
//              Utilice valores negativos para presionar.
//      AnguloMetal             : Gira el bloque de grapas respecto de la boca.
//              Valores negativos para giro hacia abajo.   
//      LargoFundamental        : Largo principal del aparato.
//              Valor por defecto 121.5*L.
//      AnchoFundamental        : Ancho de la base.
//              Valor por defecto 26.7*L.
//      AltoBase                : Alto de la base soporte.
//              Valor por defecto 8.8*L.
//      LargoSuperior           : Referencia para el largo de la cabeza
//              de la grapadora. Valor por defecto 107.0*L.  
//      AnchoSuperior           : Referencia para el ancho de la cabeza
//              de la grapadora. Valor por defecto 16.1*L.
//      AltoSuperior            : Referencia para el alto de la cabeza
//              de la grapadora. Valor por defecto 12.9*L.
//      EjeDesplazado           : Desplazamiento del eje de giro en X.
//              Valor por defecto 8.2*L.
//      EjeAlto                 : Desplazamiento del eje de giro en Y.
//              Valor por defecto 17.3*L.
//      DiametroEje             : Diametro del eje de giro.
//              Valor por defecto 3.3*L.
//      GruesoMetal             : Grueso normal de laminas metalicas.
//              Valor por defecto 0.7*L.
//      TexturaPrincipal        : Textura principal del aparato.
//              Valor por defecto EGPP_TexturaPrincipal.
//      TexturaMetal            : Textura del cargador y soporte de grapas.
//              Valor por defecto EGPP_TexturaMetal.
//      TexturaMetalFijo        : Textura del eje de giro en la base.
//              Valor por defecto EGPP_TexturaMetalFijo.
//      TexturaSuperior         : Textura de la cabeza.
//              Valor por defecto EGPP_TexturaSuperior.
//      TexturaPlastico         : Textura punta de la cabeza.
//              Valor por defecto EGPP_TexturaPlastico.
//
// La grapadora con parametros nulos
// se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <   0,   0, - 14 >*L
//      Maximo  = < 122,  36,   14 >*L   
// Boca de engrapadora hacia X+, gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare EGPP_DefaultTexturaPrincipal        
//      Textura principal del aparato.
// #declare EGPP_DefaultTexturaMetal            
//      Textura del cargador y soporte de grapas.
// #declare EGPP_DefaultTexturaMetalFijo        
//      Textura del eje de giro en la base.
// #declare EGPP_DefaultTexturaSuperior         
//      Textura de la cabeza.
// #declare EGPP_DefaultTexturaPlastico         
//      Textura punta de la cabeza.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare EGPP_TexturaPrincipal               = texture { ... }        
//      Textura principal del aparato.
// #declare EGPP_TexturaMetal                   = texture { ... }
//      Textura del cargador y soporte de grapas.
// #declare EGPP_TexturaMetalFijo               = texture { ... }
//      Textura del eje de giro en la base.
// #declare EGPP_TexturaSuperior                = texture { ... }
//      Textura de la cabeza.
// #declare EGPP_TexturaPlastico                = texture { ... }
//      Textura punta de la cabeza.
// #declare EGPP_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "EGPP.inc"
// object        { EGPP_EnGrapadora( 0, 0 ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "EGPP.inc"   
// object                       {
//   EGPP_EnGrapadoraParaPapel( 0, 0, 0.1215, 0.0267, 0.0088,
//         0.1070, 0.0161, 0.0129, 0.0082, 0.0173, 0.0033, 0.0007,
//         EGPP_TexturaPrincipal, EGPP_TexturaMetal, EGPP_TexturaMetalFijo,
//         EGPP_TexturaSuperior, EGPP_TexturaPlastico )
// }
//        
// Con modificadores
// #include "EGPP.inc"
// #include "textures.inc"
// #declare EGPP_TexturaPrincipal   = PinkAlabaster
// object        { EGPP_EnGrapadora( 0, 0 ) }
// 

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;

camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "EGPP.inc"

#local FactorAcercamiento       = 10;                                   
                                   
object                  {
  EGPP_EnGrapadora( 3, 0 )          
  translate             -0.060*x-0.018*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
  
}





