// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com Escazu, San Jose,  
// Apdo. 964-1250 Es Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 22 enero 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// PBTT PalitaBasuraTodoTipo
// El archivo dibuja una palita para basura de uso domestico.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro PBTT_PalitaBasura()    
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro PBTT_PalitaBasuraTodoTipo(
//        AltoPalita, Abertura, AberturaPosterior, Lateral,
//        GruesoPlastico, AltoTotal, DiametroPalo,
//        TexturaPalita, TexturaMadera )
//      AltoPalita              : Referencia para el alto de la palita contenedora
//          de desechos. Valor por defecto 54*L.
//      Abertura                : Abertura frontal en X de la pala.
//          Valor por defecto 200*L.
//      AberturaPosterior       : La abertura posterior debe ser menor a la frontal.
//          Valor por defecto 143*L.                             
//      Lateral                 : Referencia para la medida lateral en Z de la pala.
//          Valor por defecto 168*L.
//      GruesoPlastico          : Grosor del plastico o material de la palita.
//          Valor por defecto 1.5*L.
//      AltoTotal               : Referencia para el alto total de la palita con la madera.
//          Valor por defecto 575*L.
//      DiametroPalo            : Diametro del palo que soporta la palita.
//          Valor por defecto 17*L.
//      TexturaPalita           : Textura principal de la palita.
//          Valor por defecto PBTT_TexturaPalita.
//      TexturaMadera           : Textura del palo soporte.
//          Valor por defecto PBTT_TexturaMadera.
//
// La palita se encuentra aproximadamente contenido en las siguientes coordenadas.
//      Minimo  = < -100,    0,    0 >*L
//      Maximo  = <  100,  590,  175 >*L
// El eje de la palita se encuentra inclinado 5 grados hacia adelante. 
// El frente mira hacia Z-, note que el aparato se encuentra completamente
// contenido en el hemisferio Z+.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare PBTT_DefaultTexturaPalita      
//      Textura principal de la palita.
// #declare PBTT_DefaultTexturaMadera            
//      Textura del palo soporte.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare PBTT_TexturaPalita                  = texture { PBTT_DefaultTexturaPalita }        
//      Textura principal del pico.
// #declare PBTT_TexturaMadera                  = texture { PBTT_DefaultTexturaMadera }
//      Textura del soporte de madera.
//
// Para colocarlo simplemente
// #include "PBTT.inc"
// object        { PBTT_PalitaBasura( ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "PBTT.inc"   
// object                       {
//   PBTT_PalitaBasuraTodoTipo( 0.054, 0.200, 0.143, 0.168, 0.0015, 0.575, 0.017,
//        PBTT_TexturaPalita, PBTT_TexturaMadera )
// }
//        
// Con modificadores
// #include "PBTT.inc"
// #include "textures.inc"
// #declare PBTT_TexturaPalita       = PinkAlabaster  
// object        { PBTT_PalitaBasura( ) }
//     

// #if ( version >= 3.7 )
#version 3.7;           
// #end

// POVRay 3.7 solicita el numero de version en el primer renglon ejecutable,
// en algunas versiones podria ser util eliminar el comentario #if ... #end
global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}      

#include "PBTT.inc"

#local FactorAcercamiento       = 2.25;
                                   
object                  {
  PBTT_PalitaBasura( )
  translate       -0.275*y 
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}





