// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho...  13 enero 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// RPCE RegletaParaCablesElectricos
// El archivo dibuja una regleta domestica para cables electricos.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal no tiene parametros. 
// #macro RPCE_Regleta()
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro RPCE_RegletaParaCablesElectricos( AltoRegleta, AnchoHilera,
//          LargoRegleta, Separacion, Capsula, Perforacion,
//          ModoAsimetrico, BotonParalelo, FraccionRotarBoton,
//          TotalHileras, TotalPorHilera,
//          TexturaBase, TexturaCapsula,
//          TexturaTornillo, MaterialBoton )
//      AltoRegleta             : Alto Y de referencia de la regleta.
//          Valor por defecto 22*L.
//      AnchoHilera             : Ancho Z de cada hilera. 
//          Valor por defecto 36.6*L.
//      LargoRegleta            : Largo X de referencia de la regleta.
//          Valor por defecto 207*L.
//      Separacion              : Separacion X entre cada tomacorriente.
//          Valor por defecto 26.75*L.
//      Capsula                 : Tamano referencia de la capsula para enchufes.
//          El valor Y del vector corresponde al alto que sobresale.
//          Valor por defecto <19.72,2.5,23.29>*L.
//      Perforacion             : Dimension para el tamano de perforacion Simetrico.
//          Valor por defecto <13.60,10.50>*L.
//      ModoAsimetrico          : "true" para dibujar una entrada mayor que otra,
//          "false" las dos entradas principales son iguales. Valor por defecto "true".
//      BotonParalelo           : "true" el boton se dibuja paralelo al eje Z,
//          "false" paralelo al eje X. Valor por defecto "true". 
//      FraccionRotarBoton      : Fraccion propia para apretar y encender el boton.
//          Valor por defecto 0.0.
//      TotalHileras            : Total de hileras a lo largo de tomacorrientes.
//              Valor por defecto 1.
//      TotalPorHilera          : Total de tomacorrientes en cada hilera anterior.
//              Valor por defecto 6.
//      TexturaBase             : Textura principal para aplicar.
//              Valor por defecto RPCE_TexturaBase.
//      TexturaCapsula          : Textura para los tomacorrientes.
//              Valor por defecto RPCE_TexturaCapsula.
//      TexturaTornillo         : Textura para los tornillos.
//              Valor por defecto RPCE_TexturaTornillo.
//      MaterialBoton           : Material para el boton. No se afecta por FraccionRotarBoton.
//              Valor por defecto RPCE_MaterialBoton.
//
// La regleta (sin boton) se encuentra completamente contenida en las siguientes coordenadas.
//      Minimo  = <-105,   0  , - 20 >*L
//      Maximo  = < 105,  22.5,   20 >*L      
// Con boton el maximo es menor a 30*L en Y.
// El boton se encuentra hacia el lado X+. En cada tomacorriente, la tierra se encuentra
// en sentido X-, la apertura ancha hacia Z+. 
//
// Estas son variables predefinidas o generadas en el
// interna de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare RPCE_DefaultTexturaBase  
//      Textura principal para aplicar.
// #declare RPCE_DefaultTexturaCapsula      
//      Textura para los tomacorrientes.
// #declare RPCE_DefaultTexturaTornillo           
//      Textura para los tornillos.
// #declare RPCE_DefaultMaterialBoton       
//      Material para el boton. 
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare RPCE_Seed                           = 1030;                 
//      Semilla para aleatorizar el giro de los tornillos.
// #declare RPCE_TexturaBase                    = RPCE_DefaultTexturaBase
//      Textura principal para aplicar.
// #declare RPCE_TexturaCapsula                 = RPCE_DefaultTexturaCapsula
//      Textura para los tomacorrientes.
// #declare RPCE_TexturaTornillo                = RPCE_DefaultTexturaTornillo
//      Textura para los tornillos.
// #declare RPCE_MaterialBoton                  = RPCE_DefaultMaterialBoton
//      Material para el boton. 
//
// Para colocarlo simplemente
// #include "RPCE.inc"
// object        { RPCE_Regleta() }
//                                  
// Ejemplo con la macro detallada, mismo objeto default
// #include "RPCE.inc"   
// object                       {
//   RPCE_RegletaParaCablesElectricos( 0.022, 0.0366, 0.207, 0.02675, 
//          <0.01972,0.0025,0.02329>,<0.0136,0.0105>,true,true,0,1,6, 
//          RPCE_TexturaBase, RPCE_TexturaCapsula,
//          RPCE_TexturaTornillo, RPCE_MaterialBoton )
// }
//        
// Con modificadores
// #include "RPCE.inc"
// #include "textures.inc"
// #declare RPCE_TexturaBase   = PinkAlabaster
// object        { RPCE_Regleta() }
// 
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "RPCE.inc"

#local FactorAcercamiento       = 8;

object                          {
  RPCE_Regleta()  
  rotate          -90*x  
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z      
}


