// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 3 febrero 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ITFD InstrumentalTallerFantasiaDomestico
// El archivo dibuja un taller ficticio...
// Simplemente son inventados, pese al parecido con algo que usted haya visto,
// lo "divertido" es utilizar intensamente el archivo
// #include "functions.inc", y unos poquitos 
// rectangulos, cilindros, esferas y text para uniones y cosas asi... 
// Ademas se utilizaron casi textuales funciones de archivos por Alexander Enzmann
// en el subdirectorio POVRay objects\quartic\*.pov 
// siendo entidades matematicas, supuse que no le molestaria. 
//
// La macro principal no tiene parametros.
// #macro ITFD_Taller( )   
//
// Las dimensiones del taller son :
//      Alto total              =  1690*L 
//      Alto total (con texto)  =  1760*L
//      Fondo Z                 = -1725*L..1725*L
//      Frente X                = -3020*L..2800*L   
// Se dibuja parcialemente centrado sobre el origen del plano XZ.
// Doble frente identico en ambos sentidos Z, con gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare ITFD_TotalArregloTexturas      = 30;   
//      Total de texturas del arreglo
//      ITFD_ArregloTexturas que contiene las texturas a aplicar.                      
// #declare ITFD_TotalArregloMateriales    = 3;                  
//      Total de materiales del arreglo
//      ITFD_ArregloMateriales que contiene materiales a aplicar.       
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ITFD_BanderaTexto                           = on;
//      Valor "off" elimina el texto.  "on" si lo dibuja.
// #declare ITFD_Texto                                  = "f(X)"; 
//      Texto a escribir.
// #declare ITFD_FactorXTexto                           = 1.00;             
//      Para corregir el largo del soporte horizontal del texto en forma
//      proporcional.                                                    
// #declare ITFD_TranslateTexto                         = <0,0,0>;
//      Para corregir la posicion del texto. No concuerda con
//      la escala real aplicada.   
// #declare ITFD_ArregloTexturas
//      Solo se utilizan los primeros 18 elementos del arreglo como texturas,
//      modificando este archivo por prueba y error 
//      puede cambiar la apariencia general del instrumental.               
// #declare ITFD_ArregloMateriales
//      Solo se utiliza el primer material, puede modificarlo
//      libremente.
//      
// Para colocarlo simplemente
// #include "ITFD.inc"
// object        { ITFD_Taller( ) }
//
// Otro ejemplo con modificador
// #include "ITFD.inc"  
// #declare ITFD_ArregloTexturas[0]        = PinkAlabaster
// object        {
//      ITFD_Taller( )
// }
//
                                               
#include "stones.inc"    
#include "metals.inc"    
#include "woods.inc"
#include "textures.inc"                                           
#declare ITFD_L                         = 0.001;                                    

#declare ITFD_BanderaTexto      = on;

#declare ITFD_Texto             = "f(X)"; 

#declare ITFD_FactorXTexto      = 1.00;    

#declare ITFD_TranslateTexto    = <0,0,0>;
                                     
#declare ITFD_TotalArregloTexturas      = 30;                         
#declare ITFD_TotalArregloMateriales    = 3;                         
                               
#declare ITFD_ArregloTexturas           = array [ ITFD_TotalArregloTexturas ]
#declare ITFD_ArregloMateriales         = array [ ITFD_TotalArregloMateriales ]


   
#declare ITFD_TexturaDefault            = 0;
#declare ITFD_TexturaExtraA             = 1;  
#declare ITFD_TexturaMesaA              = 2;  
#declare ITFD_TexturaSeguraA            = 3;
#declare ITFD_TexturaPatasA             = 4;                                                            
#declare ITFD_TexturaFiloA              = 5;  
#declare ITFD_TexturaBarraSoporteA      = 6;    
#declare ITFD_TexturaSoporteBarraA      = 7; 
#declare ITFD_TexturaCorchoA            = 8;   
#declare ITFD_TexturaFondoA             = 9;
#declare ITFD_TexturaTechoA             = 10; 
#declare ITFD_TexturaBaseA              = 11;   
#declare ITFD_TexturaBaseB              = 12;   
#declare ITFD_TexturaCubiertaA          = 13; 
#declare ITFD_TexturaBarraB             = 14;  
#declare ITFD_TexturaTuberia            = 15;   
#declare ITFD_TexturaBaldosa            = 16; 
#declare ITFD_TexturaTexto              = 17;

#declare ITFD_MaterialVidrioA           = 0;

#declare ITFD_ArregloTexturas[ ITFD_TexturaDefault ]            =
   texture                      { 
     Polished_Chrome
   }  

#local C                = 1;
#while ( C < ITFD_TotalArregloTexturas )
  #declare ITFD_ArregloTexturas[ C ]    = ITFD_ArregloTexturas[ 0 ]
  #local C                              = C+1;
#end  // #while ( C < 15 )  
      
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaExtraA ]            =
   texture                      { 
     Polished_Chrome
   }  
   
#declare ITFD_ArregloTexturas[ ITFD_TexturaMesaA  ]            =
   texture                      { 
     Polished_Chrome
   }  

#declare ITFD_ArregloTexturas[ ITFD_TexturaSeguraA  ]            =
   texture                      {
     Polished_Chrome
   }             
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaPatasA  ]            =
   texture                      { 
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaFiloA  ]            =
   texture                      {
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaBarraSoporteA  ]            =
   texture                      {
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaSoporteBarraA  ]            =
   texture                      {
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaCorchoA  ]            =
   texture                      { 
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaFondoA  ]            =
   texture                      { 
     Polished_Chrome
   }  

#declare ITFD_ArregloTexturas[ ITFD_TexturaTechoA  ]            =
   texture                      { 
     Polished_Chrome
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaBaseA  ]            =
   texture                      {
     T_Gold_2C  
     scale              0.1
   }  
 
#declare ITFD_ArregloTexturas[ ITFD_TexturaBaseB  ]            =
   texture                      {
     PinkAlabaster 
     scale              0.1
   }  
  
#declare ITFD_ArregloTexturas[ ITFD_TexturaCubiertaA ]            =
   texture                      {   
     Polished_Chrome
     normal                     {
       bumps
       scale            0.01
     }      
     finish                     {
       metallic
     }
     scale              0.1
   }  
   
#declare ITFD_ArregloTexturas[ ITFD_TexturaBarraB  ]            =
   texture                      {
     T_Stone41 
     scale              0.01
   }  

#declare ITFD_ArregloTexturas[ ITFD_TexturaTuberia  ]            =
   texture                      {
     T_Stone31 
     scale              1
   }  
     
#declare ITFD_ArregloTexturas[ ITFD_TexturaBaldosa  ]            =
   texture                      {
     PinkAlabaster 
     scale              0.01
   }  
     
#declare ITFD_ArregloTexturas[ ITFD_TexturaTexto    ]            =
   texture                      {
     T_Stone31 
     scale              1
   }  
          
#declare ITFD_ArregloMateriales[ ITFD_MaterialVidrioA ]            =
   material                      { 
      M_Glass 
   }  
   

 
 
#include "functions.inc"  
#include "shapes_old.inc"   
#include "shapesq.inc" 
#include "shapes2.inc"
#include "shapes3.inc"
// Declaracion de objetos      
#macro ITFD_Objeto12( TexturaAplicar )
  object                {                
	#local LCorner = <-3.2, -0.1, -2.5>;  #local RCorner = <3.2, 2, 2.5>;
	intersection {
		isosurface {
			function  { f_crossed_trough(x,y,z, -0.05) }
				//P0= Field Strength
			contained_by { box { LCorner, RCorner } }
			max_gradient 0.5
		}
		box { LCorner*0.9999, RCorner*0.9999  }
		scale 0.05         
		rotate          -90*x
	}
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto12()  

#macro ITFD_Objeto19( TexturaAplicar )
  object                {    
    isosurface {
	function  { f_enneper(x,y,z, -0.1) }
		//P0= Field Strength
	contained_by { box { <-3.5, -3.5, -3.8>, <3.5, 3.5, -0.25> } }
	max_gradient 85
	scale 0.02  rotate y*15
    }
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto19()  

#macro ITFD_Objeto21( TexturaAplicar )
  object                {
	#local LCorner = <-0.0, -0.9, -0.9>;  #local RCorner = <0.8, 0.9, 0.9>;
	intersection {
		isosurface {
			function  { f_folium_surface(x,y,z, -0.02, 15, 15) }
				//P0= Field Strength
				//P1= Neck width factor - the larger you set this, the narrower the neck where the paraboloid meets the plane
				//P2= Divergence - the higher the value, the wider the paraboloid gets
			contained_by { box { LCorner, RCorner  } }
			max_gradient 1.3
		}
		box { LCorner*0.9999, RCorner*0.9999 }
		scale 0.1  
	}
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto21()  

#macro ITFD_Objeto25( TexturaAplicar )
  object                {
	#local LCorner = <-3.7, -1.7, -3.7>;  #local RCorner = <3.7, 1.7, 3.7>;
	isosurface {
		function  { f_helical_torus(x,y,z, 2, 7, 1, 0.1, 1, 0.5, 1, 6, 2.0, 0) }
			//P0= Major radius
			//P1= Nr of winding loops
			//P2= Twistness winding
			//P3= Flatness of winding?
			//P4= Threshold
			//P5= Negative minor radius?
			//P6= Another fatness of winding control
			//P7= Groove period
			//P8= Groove amplitude
			//P9= Groove phase
		contained_by { box { LCorner, RCorner } }
		max_gradient 13
		texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
		scale 0.25
	}      
  }	  
#end  // #macro ITFD_Objeto25()   

#macro ITFD_Objeto28( TexturaAplicar )
  object                {    
	#local LCorner = <-4, -4, -4>;  #local RCorner = <4, 4, 4>;
	isosurface {
		function { f_hex_x(x,y,z, 1) } 
			//P0= not used
		threshold 0.6
		contained_by { box { LCorner, RCorner } }
		max_gradient 1
	}     
    scale               0.02	
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto28()  

#macro ITFD_Objeto40( TexturaAplicar )
  object                        {
	#local LCorner = <-1, -0.05, -1>;  #local RCorner = <1, 0.05, 1>;
	intersection {
		isosurface {
			function { f_mesh1(x,y,z, 1/8, 1/8, 1/10, 0.01, 1/10) }
				//P0= X frequency
				//P1= Z frequency
				//P2= scale (X-Z)
				//P3= amplitude
				//P4= scale Y
			threshold  0.001
			contained_by { box { LCorner, RCorner } }
			max_gradient 0.2
			texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
		}
		box { LCorner*0.9999, RCorner*0.9999  texture 
		        { ITFD_ArregloTexturas[ TexturaAplicar ] } }
	}                               
   }
#end  // macro ITFD_Objeto40() 
  	
#macro ITFD_Objeto61( TexturaAplicar ) 
  object                        {
	#local LCorner = <-1.1, -1.1, -1.1>;  #local RCorner = <1.1, 1.1, 1.1>;
	isosurface {
		function { f_rounded_box(x,y,z, 0.3, 1, 1, 1) }
			//P0= radius rounded corner
			//P1= scale x
			//P2= scale y
			//P3= scale z
		contained_by { box { LCorner, RCorner } }
		max_gradient 1
		texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
		scale 1  
	}
  }	
#end  // #macro ITFD_Objeto61  

#macro ITFD_Objeto70( TexturaAplicar )
  object                {     
	isosurface {
		function { f_sphere(x,y,z, 1) + sin(f_th(x,y,z)*20)*0.05*(1-y*y) }
		contained_by { sphere { 0, 1.1 } }
		max_gradient 1.5
		scale 0.1
	}
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto70()  

#macro ITFD_Objeto73( TexturaAplicar )
  object                        {
	isosurface {
		function  { f_torus_gumdrop(x,y,z, -0.01) }
			//P0= Field Strength
		contained_by { sphere { 0, 2.1 } }
		max_gradient 1.1
		texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
		scale 0.1      
	}                  
  }
#end  // #macro ITFD_Objeto73()	

#macro ITFD_Objeto79( TexturaAplicar )
  object                {    
       intersection{ 
         object { Glob_5 
           rotate          180*z            //-------------------------------
           scale<1,1,1>*0.1    
         }
         sphere         { 0, 0.1 }  
       } // ---------------------------------- end of object
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto79()  

#macro ITFD_Objeto85( TexturaAplicar )
  object                {    
      intersection{
        object          { 
          Cubic_Saddle_1     //--------------------------------
          scale   0.05      
        } 
        sphere { 0, 0.1 }
      } // ------------------------------------ end of object
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto85()  

#macro ITFD_Objeto87( TexturaAplicar )
  intersection                {    
     object{ 
       Folium 
       scale            0.05
       rotate           -90*y            //--------------------------------
      } // ------------------------------------ end of object
      sphere            { 0, 0.1 }
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto87()    

#macro ITFD_Objeto88( TexturaAplicar )
  intersection                {    
     object{ 
       Helix 
       scale            0.05
       rotate           -0*y            //--------------------------------
      } // ------------------------------------ end of object
      sphere            { 0, 0.1 pigment { Clear } }
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto87()  


#macro ITFD_Objeto93( TexturaAplicar )
  intersection                {    
      object{ 
        Quartic_Loop_1   //----------------------------------
        scale 0.1 
        rotate  -45*y
      } // ------------------------------------ end of object
      sphere { 0, 0.1 }
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto93()  

#macro ITFD_Objeto111( TexturaAplicar )
  object                {    
    Pyramid
    scale       0.1 
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto111()  

#macro ITFD_Objeto113( TexturaAplicar )
  object                {
    Tetrahedron
    scale               0.05    
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto113()  

#macro ITFD_Objeto128( TexturaAplicar )
      superellipsoid{ <1.00,0.25> 

        scale  0.1 
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto128()  

#macro ITFD_Objeto138( TexturaAplicar )
  intersection                {   
    object { Hyperboloid scale 0.1 } 
    sphere              { 0, 0.1 pigment { Clear }}
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto138()  

#macro ITFD_Objeto143( TexturaAplicar )
  object                {    
#local My_Test_Object =
difference{
 union{ // positiv
   sphere{ <0,0,0>, 2.75 
           scale<1,1,1>  rotate<0,0,0>  translate<0,0,0>  
         } // end of sphere ---------------------------- 
   torus{ 1.5,0.3 
          scale <1,1,1> rotate<0,0,0> translate<0,2.5,0>
        } // end of torus ------------------------------              
 }// end of union

 sphere  { <0,0,0>, 2.15 
           scale<1,1,1>  rotate<0,0,0> translate<0,0,0>  
         }  // end of sphere ----------------------------  
 cylinder{ <0,-1.5,0>,<0,3.5,0>, 1.50 
           scale <1,1,1> rotate<0,0,0> translate<0,0,0>
         } // end of cylinder  -------------------------
  scale<1,0.6,1> rotate<0,0,0> translate<0,0,0>  
} // end of diff  
    Segment_of_Object( My_Test_Object, -225 )
    scale               0.02
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto143()  

#macro ITFD_Objeto156( TexturaAplicar )  
      object{ Supercone(<0.00,0.00,0.00>, 0.5, 1.0, // point A, axis Ax, axis Az, 
                  <0.00,1.70,0.00>, 0.7, 0.3) // point B, axis Bx, axis Bz) 

        texture{ ITFD_ArregloTexturas[ TexturaAplicar ]
               } // end texture ------------------

        scale<1,1,1> 
        rotate<0,0,0> 
        translate<0,0,0>
      } // ----------------------------------------------------------------
#end  // #macro ITFD_Objeto156()   

#macro ITFD_Objeto162( TexturaAplicar )
      object{ Facetted_Sphere( 80, 3 )// ( Quarter_Meridian_Segments, Equatorial_Segments)
        texture{ ITFD_ArregloTexturas[ TexturaAplicar ] }
        scale <1,0.75,1>*0.7
        rotate <0,0,0>
        translate< 0,0,0>
      } // end of object  //-------------------------------------------------------- 
#end  // #macro ITFD_Objeto162() 

#macro ITFD_Objeto165( TexturaAplicar )
  object{ Round_Pyramid_N_in( // defined by incircle radii 
                            5 , // number of side faces 
                            <0,00,0>, 1.00, <0,1.25,0>, 0.00 , // A, radius A, B, radius_B, 
                            0.05, // wire radius or border radius 
                            0,   // 1 = filled, 0 = wireframe
                            0   // 0 = union, 1 = merge for transparent materials           
                          ) //-------------------------------------------------------------

        texture{ ITFD_ArregloTexturas[ TexturaAplicar ]
               } // end of texture

         scale <1,1,1>*1 
         rotate <0,0,0>
         translate< 0, 0, 0>
  } // end of object -----------------------------------------------------------------   
#end  // ITFD_Objeto165()
 
#macro ITFD_Objeto172( TexturaAplicar )
      object{ Rounded_Tube_AB( <-1,-0.2,-0.2>, // Point_A
                         <1.0,0.9,-0.3>, // Point_A
                         0.95, // tube radius outside
                         0.50, // tube inner radius 
                         0.12, // border radius 
                         1, // 0 = union, 1 = merge for transparent materials 
                       ) //--------------------------------------------------  
        texture{ ITFD_ArregloTexturas[ TexturaAplicar ] }
        scale <1,1,1> 
        rotate<0,0,0> 
        translate<0,0,0>
      } // end of object ----------------------------------------------------- 
#end  // #macro ITFD_Objeto172()  

#macro ITFD_Objeto175( TexturaAplicar )
  intersection                { 
    object { Paraboloid_X scale 0.1 }
    sphere { 0, 0.1 pigment { Clear }}   
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto175()  

#macro ITFD_Objeto184( TexturaAplicar )
  object                {    
isosurface { //-------------------------------------------------------------

  function{
    abs(x)-2+y
  }
  contained_by { box { -2, 2 } }
  accuracy 0.003
  max_gradient 5

} // end of isosurface 
    scale 0.02
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto184()  

#macro ITFD_Objeto188( TexturaAplicar )
  object                {       
isosurface { //-------------------------------------------------------------

  function{
    f_dupin_cyclid(
       x,y,z,
       -0.05, // field strength,
       1,     // major radius of torus,
       0.25,  // minor radius of torus,
       0.25,  // x displacement of torus,
       0.0,   // y displacement of torus,
       0.75   // radius of inversion
     ) 
  }
  contained_by {sphere {0,1.25}}
} // end of isosurface -----------------------------------------------------  
    scale 0.1
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto188()  

#macro ITFD_Objeto191( TexturaAplicar )
  object                {    
isosurface { //-------------------------------------------------------------

  function {
              y - (x*x + z*z)*0.5
	   }
  open
  contained_by {box {<-1,-1,-1>, < 1, 1, 1>}}
  threshold 0
  accuracy 0.0001
  max_gradient 5
} // end of isosurface -----------------------------------------------------  
    scale       0.1
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto191()  

#macro ITFD_Objeto193( TexturaAplicar )
  object                {    
//--------------------------------------------------------------------------
#local fn_A = function { sqrt(y*y + z*z) - 0.8 }
#local fn_B = function { abs(x)+abs(y)-1 }
#declare Blob_threshold=0.125;

isosurface { //-------------------------------------------------------------

  function {
      (1+Blob_threshold)
      -pow(Blob_threshold,fn_A(x,y,z))
      -pow(Blob_threshold,fn_B(x,y,z))
  }
  max_gradient 4
  contained_by { box { <-4,-2,-3>, <4,2,3> } }

  scale 0.5
  rotate<0,20,0>rotate<-45,0,0>
  translate <0, 1.5, 0.2>
} // end of isosurface -----------------------------------------------------
    scale 0.05 
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto193()  

#macro ITFD_Objeto198( TexturaAplicar )
  intersection                {    
isosurface { // ------------------------------------------------------------
  function{  
       y - cos(sqrt(x*x + z*z)*5*pi)*0.08
	  }                                         
  open	  
  threshold 0
  accuracy 0.0001
  max_gradient 5
  contained_by {box {<-1.5,-0.25,-1.5>, < 1.5, 1, 1.5>}}
  //open
  scale 0.1
} // end of isosurface -----------------------------------------------------     
sphere              { 0, 0.1 pigment { Clear } } 
    rotate      -90*x
    material { ITFD_ArregloMateriales[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto198()  

#macro ITFD_Objeto199( TexturaAplicar )
  isosurface { //-------------------------------------------------------------

      function { sin( 4 *y*2*pi ) /15
             + sqrt(x*x*4 + z*z*4) - 0.5 }
      threshold 0
      contained_by {box {<-1,0,-1>, < 1, 1, 1>}}
      max_gradient 10
      accuracy 0.005
      open  // optional

      texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
      scale 1
      translate -0.5*y
      scale     0.2
  } // end of isosurface ----------------------------------------------------- 
#end  // #macro ITFD_Objeto199()

#macro ITFD_Objeto211( TexturaAplicar )
  object                {  
    superellipsoid{ <0.50,3.50> }
    scale               0.1
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto211()  

#macro ITFD_Objeto218( TexturaAplicar )
  object                {    
isosurface { //-------------------------------------------------------------
  function{
     f_spiral(
        x,y,z,
        0.2,  // distance between windings,
        0.05, // thickness,
        0.9,  // outer diameter of the spiral,
        0,    // not used,
        0,    // not used,
        0.75   // cross section type
     )
  } 
  open         
 contained_by {sphere {<0,0,0>,1}}
 threshold 0
 max_gradient 5
 scale          0.1
 rotate 90*x
} // end of isosurfa
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto218()  

#macro ITFD_Objeto224( TexturaAplicar )
  object                {    
isosurface { //-------------------------------------------

  function{
   f_rounded_box(x,y,z,0.3,1,1,1)
   -(f_leopard(x*11,y*11,z*11)*0.25)
   }
   open
  threshold 0
  contained_by {box {<-1,-1,-1>*1.35,<1,1,1>*1.35}}
  max_gradient 3.0
  accuracy 0.0001
  scale         0.1
} // end of isosurface -----------------------------------
    texture { ITFD_ArregloTexturas[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto224()  
                              
#macro ITFD_Objeto227( TexturaAplicar )
  object                {    
isosurface {

  function{
  f_rounded_box(x,y,z,0.3,1.9,0.9,0.9)
   -f_marble(x*3,y*2,z*2)*0.15
   -f_bumps(x*3,y*2,z*3)*0.75
  }
  open
  contained_by {box {<-2,-1,-1>*2.2,<2,1,1>*2.2}}
  accuracy 0.003
  max_gradient 5
  scale 0.07
} // end of isosurface  -----------------------------------------------
    material { ITFD_ArregloMateriales[ TexturaAplicar ] }
  }                                                
#end  // #macro ITFD_Objeto227()  
                              
#macro ITFD_Objeto236( TexturaAplicar )
isosurface {   // ----------------------------------------------------
  
  function{ 
  sqrt(  0.5*x*x + y*y + z*z) - 0.85 
  - f_noise3d( x*12, y*12, z*12 )
  }
   
  contained_by { box { -2.5, 2.5 } }
  accuracy 0.002
  max_gradient 4

    texture{ ITFD_ArregloTexturas[ TexturaAplicar ] }
  scale 0.75
  rotate<0,0,0> 
  translate <0,1.4,0> 
}
 //
#end  // #macro ITFD_Objeto236()
   
                
#macro ITFD_Instrumental1() 
  union                         {   
    difference                  {
      box                         {
        < -1, -0.5, -1 >,
        < +1,  0.0, +1 > 
        scale                     0.5 
      }
      cylinder                  {
        -y, y, 0.3
      }  
      texture                   {
        ITFD_ArregloTexturas[ ITFD_TexturaMesaA ]
      }
    } 
    
    union                       {
      #local C                  = 0;
      #while ( C < 3 )
        object                      {
          ITFD_Objeto40( ITFD_TexturaSeguraA )
          rotate                90*z
          scale                     0.5
          translate             -0.48*x
          rotate                90*C*y
        }
        #local C                = C+1;
      #end // #while ( C < 3 )    
      }
      object                      {
         ITFD_Objeto165( ITFD_TexturaPatasA )    
         scale                  0.40
         rotate                 -90*y
         translate              -0.5*y
      }
      union                             {
        #local C                        = 0;
        #while ( C < 3 )
          object                        {
            ITFD_Objeto25( ITFD_TexturaFiloA )  
            scale               0.1        
            rotate              90*z  
            scale               <0.5,1,1>
            translate           0.1*y+C*0.1*x
          }                     
          #local C              = C+1;
        #end  // #while ( C < 3 )      
        object                          {
          ITFD_Objeto199( ITFD_TexturaBarraSoporteA )
          rotate                90*z
          scale                 <4,0.25,0.25>
          translate             0.1*y
        }    
        object                          {
          ITFD_Objeto73( ITFD_TexturaSoporteBarraA )
          scale                 0.75         
          //rotate                90*z
          translate             -0.40*x+0.1*y
        }
        object                          {
          ITFD_Objeto73( ITFD_TexturaSoporteBarraA )
          scale                 0.75         
          //rotate                90*z
          translate             +0.40*x+0.1*y
        }    
        object                          {
          ITFD_Objeto88( ITFD_TexturaSoporteBarraA )
          translate             +0.4*z+0.25*y
        } 
        object                          {
          ITFD_Objeto162( ITFD_TexturaBarraSoporteA )
          scale                 0.1
          translate             0.5
        }
        object                          {
          ITFD_Objeto162( ITFD_TexturaBarraSoporteA )
          scale                 0.1
          translate             0.5 
          translate             -x
        } 
        object                          {
          ITFD_Objeto156( ITFD_TexturaPatasA )
          scale                 0.30
          translate             0.4*z-0.3*x
        } 
        object                          {
          ITFD_Objeto28( ITFD_TexturaCorchoA )
          scale         1
          translate     0.4*z-0.1*x+0.2*y
        }                
        object                          {
          ITFD_Objeto172( ITFD_TexturaMesaA )
          scale         0.05
          rotate        90*y        
          translate     -0.5*z-0.4*x
        }
        object                          {
          ITFD_Objeto172( ITFD_TexturaMesaA )
          scale         0.05
          rotate        90*y        
          translate     -0.5*z+0.4*x
        }
      }
  }
#end  // #macro ITFD_Instrumental1()                
   
                        
                        
#macro ITFD_DefaultInstrumental1()
  object                        {
    #local L                            = ITFD_L;
    ITFD_Instrumental1()
  }
#end  // #macro ITFD_DefaultInstrumental1()    

#macro ITFD_Instrumental2() 
  difference                    {        
    union                         {
      object                              {
        ITFD_Objeto12( ITFD_TexturaFondoA )    
        scale             <10/3,5,5>
        translate         0.5*z
      } 
      object                              {
        ITFD_Objeto184( ITFD_TexturaTechoA ) 
        scale             <40/3,1,40/3>
        translate         +0.5*y
      }      
      object                              {
        ITFD_Objeto128( ITFD_TexturaBaseA ) 
        rotate            90*x
        translate         0.1*y
        scale             <5,1,5>
        translate         -0.5*y
      } 
      object                              {
        ITFD_Objeto87( ITFD_TexturaBaseA )
        rotate            -90*x
        scale             <1.5,4.0,1.5>
        translate         -0.45*y-0.25*z-0.2*x
      }
      object                              {
        ITFD_Objeto70( ITFD_TexturaFiloA )
        translate         0.5*y
      } 
      object                              {
        ITFD_Objeto175( ITFD_TexturaMesaA ) 
        scale             <1,6,4>
      }  
      object                              {
        ITFD_Objeto236( ITFD_TexturaCorchoA )  
        scale             0.2
        translate         -0.1*y+0.3*z
      }
      object                      {
        ITFD_Objeto143( ITFD_TexturaPatasA )
        scale             1.5
        translate        -0.25*z-0.2*x-0.1*y 
      }  
      object                      {
        ITFD_Objeto128( ITFD_TexturaPatasA ) 
        rotate            90*y
        scale             <4,0.1,0.1>
        translate        -0.25*z-0.1*x-0.1*y 
      }    
      object                      {
        ITFD_Objeto198( ITFD_MaterialVidrioA )
        rotate            0*y 
        scale             5
        translate         -0.25*z-0.1*y
      }
      object                              {
        ITFD_Objeto61( ITFD_TexturaSoporteBarraA )
        scale             <1,12,1>*0.02
        translate         -0.25*z-0.1*y-0.40*x
      }
    }
    box                                   { 
      <-1,-0.5,-1>,
      <1,-2,1>
    }
  }
#end  // #macro ITFD_Instrumental2()

#macro ITFD_DefaultInstrumental2()
  object                        {
    #local L                            = ITFD_L;
    ITFD_Instrumental2()
  }
#end  // #macro ITFD_DefaultInstrumental2()     

#macro ITFD_Instrumental3()         
  union                         { 
      object                    {
        ITFD_Objeto224( ITFD_TexturaBaseB)
        scale           <1,2,1>
      }
      object                    {
        ITFD_Objeto12( ITFD_TexturaCubiertaA )
        translate       -0.3*y
      } 
      object                    {
        ITFD_Objeto113( ITFD_TexturaPatasA )
        translate       +0.5*y
      }    
      object                    {
        ITFD_Objeto165( ITFD_TexturaCubiertaA ) 
        scale           <0.1,0.25,0.1>
        translate       +0.20*y
      } 
      object                    {
        ITFD_Objeto227( ITFD_MaterialVidrioA )
        scale           1
        translate       -0.4*y
      }
      object                      {
        ITFD_Objeto193( ITFD_TexturaFondoA )
        scale             2
        translate         -0.0*x+0.15*y
      }    
      #local C                  = 0;
      #while ( C < 4 )
        object                      {
          ITFD_Objeto218( ITFD_TexturaPatasA )
          scale             1
          translate         -0.1*z+0.25*y
          rotate                  90*C*y
        }   
        #local C                = C+1;           
      #end
      object                      {
        ITFD_Objeto85( ITFD_TexturaBaseB )
        scale             1
        translate         -0.10*x+0.1*y
      } 
      object                      {
        ITFD_Objeto93( ITFD_TexturaBaseB )
        scale             1
        translate         +0.10*x+0.1*y
      }
      object                      {
        ITFD_Objeto191( ITFD_TexturaBaseB )
        scale             1
        translate         -0.10*x+0.0*y
      }
  }
#end  // #macro ITFD_Instrumental3()

#macro ITFD_DefaultInstrumental3()
  object                        {
    #local L                            = ITFD_L;
    ITFD_Instrumental3()
  }
#end  // #macro ITFD_DefaultInstrumental3()

#macro ITFD_Instrumental4()       
  union                         {   
    object                      {
      ITFD_Objeto19( ITFD_TexturaBaseB )
      scale             1.5 
      rotate            -90*x
      translate         -0.5*x+0.5*y
    }
    object                      {
      ITFD_Objeto21( ITFD_TexturaTechoA )
      scale             1.5   
      rotate            90*y
      translate         -0.2*x+0.5*y
    } 
    object                      {
      ITFD_Objeto28( ITFD_TexturaPatasA )
      scale             1.5
      translate         +0.2*x+0.5*y
    }
    object                      {
      ITFD_Objeto40( ITFD_TexturaSoporteBarraA )
      scale             0.25
      rotate            -90*x
      translate         +0.3*x+0.3*y
    }                       
    object                      {
      ITFD_Objeto79( ITFD_TexturaBaseA )
      scale             1.5 
      translate         -0.5*x+0.0*y
    }
    object                      {
      ITFD_Objeto111( ITFD_TexturaCorchoA )
      scale             1.5        
      rotate            -90*x
      translate         +0.5*x+0.0*y
    }
    object                      {
      ITFD_Objeto138( ITFD_TexturaBarraSoporteA )
      scale             1.5       
      rotate            90*x
      translate         -0.5*x-0.4*y   
    }
    object                      {
      ITFD_Objeto188( ITFD_TexturaTechoA )
      scale             1.5
      translate         -0.2*x-0.4*y
    }
    object                      {
      ITFD_Objeto211( ITFD_TexturaSeguraA )
      scale             1.5
      translate         +0.2*x-0.4*y
    }
        object                      {
      ITFD_Objeto218( ITFD_TexturaFiloA )
      scale             5.0         
      translate         +0.0*x-0.0*y
    }  
    union                               {                     
      box                                 {
        <-0.6,-0.6,0.10>,
        <0.6,0.6,0.20>
      }   
      box                                 {
        <-0.6,-0.6,0.25>,
        <0.6,0.6,0.35>
      }
      box                                 {
        <-0.6,-0.6,0.40>,
        <0.6,0.6,0.50>
      }
      cylinder                            {
        0.1*z, 0.5*z, 0.1
        translate         +0.35*x+0.35*y
      }
      cylinder                            {
        0.1*z, 0.5*z, 0.1
        translate         -0.35*x+0.35*y
      }
      cylinder                            {
        0.1*z, 0.5*z, 0.1
        translate         -0.35*x-0.35*y
      }
      cylinder                            {
        0.1*z, 0.5*z, 0.1
        translate         +0.35*x-0.35*y
      }
      texture                           {   
        ITFD_ArregloTexturas[ ITFD_TexturaBaldosa ]
      }
    }
    rotate              90*x
  }
#end  // #macro ITFD_Instrumental4()

#macro ITFD_DefaultInstrumental4()
  object                        {
    #local L                            = ITFD_L;
    ITFD_Instrumental4()
  }
#end  // #macro ITFD_DefaultInstrumental4() 

#macro ITFD_TallerFantasiaLateral()         
  union                         {
    union                       {
      object                    {
        ITFD_DefaultInstrumental1()
        translate               -0.5*x
      } 
      object                    {
        ITFD_DefaultInstrumental3()  
        scale                   0.5
        translate               -0.25*y
        translate               +0.10*x
      }
      object                    {
        ITFD_DefaultInstrumental3()  
        scale                   0.5
        translate               -0.25*y
        translate               +0.10*x-0.50*z
      }
      object                    {
        ITFD_DefaultInstrumental3()  
        scale                   0.5
        translate               -0.25*y
        translate               +0.30*x
      }
      object                    {
        ITFD_DefaultInstrumental3()  
        scale                   0.5
        translate               -0.25*y
        translate               +0.30*x-0.50*z
      }
      object                    {
        ITFD_DefaultInstrumental4()
        translate               +1.00*x
      }
      object                    {
        ITFD_DefaultInstrumental2()
        translate               2.2*x
      }
    } 
    translate           -1.0*x-0.55*z
  }
#end  // #macro ITFD_TallerFantasiaLateral()

#macro ITFD_Taller()
  union                         { 
    object                      {
      ITFD_TallerFantasiaLateral()
    }                             
    object                      {
      ITFD_TallerFantasiaLateral()
      scale             <1,1,-1>
    } 
    #local C                    = 0;
    #while ( C < 4 )        
      cylinder                  {
        -1.5*x, 1.5*x, 0.025
        translate               ( 0.45-0.2*C )*y 
        texture  { ITFD_ArregloTexturas[ ITFD_TexturaTuberia ] }
      }                                   
      #local C                  = C+1;
    #end  // #while ( C < 4 )
    #if ( ITFD_BanderaTexto )  
      union                     {
        text {
          ttf "timrom.ttf" ITFD_Texto 0.25, 0
          scale             0.25                 
          translate         0.500*y-0.35*x-0.00*z     
          translate       ITFD_TranslateTexto*2
        }
        cylinder            {   
          0, 1.50*ITFD_FactorXTexto*x, 0.025    
          translate         0.25*y
          scale             0.25    
          translate         0.500*y-0.35*x-0.00*z 
          translate       ITFD_TranslateTexto*2
        }   
        texture                 {
          ITFD_ArregloTexturas[ ITFD_TexturaTexto ]
        }                       
      }
    #end                           
    translate                   0.5*y
    scale                       1.5 
    translate                   0.2*x
  }
#end