// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 3 febrero 2016
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY 
//
// ITFD InstrumentalTallerFantasiaDomestico
// El archivo dibuja un taller ficticio...
// Simplemente son inventados, pese al parecido con algo que usted haya visto,
// lo "divertido" es utilizar intensamente el archivo
// #include "functions.inc", y unos poquitos 
// rectangulos, cilindros, esferas y text para uniones y cosas asi... 
// Ademas se utilizaron casi textuales funciones de archivos por Alexander Enzmann
// en el subdirectorio POVRay objects\quartic\*.pov 
// siendo entidades matematicas, supuse que no le molestaria. 
//
// La macro principal no tiene parametros.
// #macro ITFD_Taller( )   
//
// Las dimensiones del taller son :
//      Alto total              =  1690*L 
//      Alto total (con texto)  =  1760*L
//      Fondo Z                 = -1725*L..1725*L
//      Frente X                = -3020*L..2800*L   
// Se dibuja parcialemente centrado sobre el origen del plano XZ.
// Doble frente identico en ambos sentidos Z, con gravedad Y-.
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.
// #declare ITFD_TotalArregloTexturas      = 30;   
//      Total de texturas del arreglo
//      ITFD_ArregloTexturas que contiene las texturas a aplicar.                      
// #declare ITFD_TotalArregloMateriales    = 3;                  
//      Total de materiales del arreglo
//      ITFD_ArregloMateriales que contiene materiales a aplicar.       
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)
// #declare ITFD_BanderaTexto                           = on;
//      Valor "off" elimina el texto.  "on" si lo dibuja.
// #declare ITFD_Texto                                  = "f(X)"; 
//      Texto a escribir.
// #declare ITFD_FactorXTexto                           = 1.00;             
//      Para corregir el largo del soporte horizontal del texto en forma
//      proporcional.                                                    
// #declare ITFD_TranslateTexto                         = <0,0,0>;
//      Para corregir la posicion del texto. No concuerda con
//      la escala real aplicada.   
// #declare ITFD_ArregloTexturas
//      Solo se utilizan los primeros 18 elementos del arreglo como texturas,
//      modificando este archivo por prueba y error 
//      puede cambiar la apariencia general del instrumental.               
// #declare ITFD_ArregloMateriales
//      Solo se utiliza el primer material, puede modificarlo
//      libremente.
//      
// Para colocarlo simplemente
// #include "ITFD.inc"
// object        { ITFD_Taller( ) }
//
// Otro ejemplo con modificador
// #include "ITFD.inc"  
// #declare ITFD_ArregloTexturas[0]        = PinkAlabaster
// object        {
//      ITFD_Taller( )
// }
//

// #if ( version >= 3.7 )
#version 3.7;           
// #end

// POVRay 3.7 solicita el numero de version en el primer renglon ejecutable,
// en algunas versiones podria ser util eliminar el comentario #if ... #end
global_settings { assumed_gamma 1.0 }

#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "ITFD.inc"
  
#local FactorAcercamiento       = 0.25;
                              
union                           {
  ITFD_Taller()       
  translate             -0.8*y+0.15*x
  rotate                -30*y
  translate       -( VecesCentroAbsoluto+1 )*( FactorAcercamiento-1 )
                        /( FactorAcercamiento )*OjoAbsoluto*L*z
}   

