// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// TPEA TelefonoPublicoExpuestoAire
// El archivo dibuja un Telefono Publico tipico en Costa Rica.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente un parametro. 
// #macro TPEA_Telefono( SeedCable )
//      SeedCable               : Inicia el generador de numeros aleatorios,
//              para modificar al azar la posicion del cable. Utilice,
//              valores negativos para no dibujar ni el cable ni el auricular.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro TPEA_TelefonoPublicoExpuestoAire( SeedCable, AltoTotal,
//              AltoCasetilla, AnchoCasetilla, ProfundidadCasetilla,
//              AltoBanner, AltoTelefono, AnchoTelefono, ProfundidadTelefono,
//              AltoAuricular, GruesoAuricular, GruesoMetal, GruesoDecorativo,
//              TexturaCasetilla, TexturaTelefono, TexturaBannerFrontal,
//              TexturaBannerLateral, TexturaMetalica, TexturaAuricular )
//      SeedCable               : Inicia el generador de numeros aleatorios,
//              para modificar al azar la posicion del cable. Utilice,
//              valores negativos para no dibujar ni el cable ni el auricular. 
//      AltoTotal               : Alto total del aparato.
//              Valor por defecto 1215*L.
//      AltoCasetilla           : Alto de la casetilla que protege al telefono.
//              Valor por defecto 740*L.
//      AnchoCasetilla          : Ancho frontal de la casetilla que protege 
//              al telefono. Valor por defecto 440*L.
//      ProfundidadCasetilla    : Profundidad lateral de la casetilla. Valor por
//              defecto 318*L.
//      AltoBanner              : Alto de la franja superior de la casetilla.
//              Valor por defecto 146*L.
//      AltoTelefono            : Referencia para el alto del telefono.
//              Valor por defecto 260*L.
//      AnchoTelefono           : Ancho del telefono.
//              Valor por defecto 190*L.
//      ProfundidadTelefono     : Profundidad del telefono.  
//              Valor por defecto 160*L.
//      AltoAuricular           : Alto del auricular.
//              Valor por defecto 165*L.
//      GruesoAuricular         : Grueso del auricular.
//              Valor por defecto 44*L.
//      GruesoMetal             : Grueso de la placa metalica.
//              Valor por defecto 2*L.
//      GruesoDecorativo        : Grueso de perforaciones a placa metalica,
//              que sirven para incrementar la exposicion al aire.
//              Valor por defecto 10*L.
//      TexturaCasetilla        : Textura principal de la casetilla.
//              Valor por defecto TPEA_TexturaCasetilla.
//      TexturaTelefono         : Textura del aparato telefonico.
//              Valor por defecto TPEA_TexturaTelefono.
//      TexturaBannerFrontal    : Logo frontal como textura. 
//              Valor por defecto TPEA_TexturaBannerFrontal.
//      TexturaBannerLateral    : Logo lateral como textura.
//              Valor por defecto TPEA_TexturaBannerLateral.
//      TexturaMetalica         : Textura del cable. 
//              Valor por defecto TPEA_TexturaMetalica.
//      TexturaAuricular        : Textura del auricular.
//              Valor por defecto TPEA_TexturaAuricular.
//
// El telefono publico
// se encuentra completamente contenido en las siguientes coordenadas.
//      Minimo  = < -220,    0,  -370 >*L
//      Maximo  = <  220, 1215,    80 >*L 
// La casetilla sobresale del plano XZ, con frente que mira hacia Z-.
// El poste se sumerge en Z+. De tal forma que el plano XZ separa el poste y la 
// casetilla. Gravedad Y-. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare TPEA_DefaultTexturaCasetilla        
//      Textura principal de la casetilla.
// #declare TPEA_DefaultTexturaTelefono            
//      Textura del aparato telefonico.
// #declare TPEA_DefaultTexturaBannerFrontal        
//      Logo frontal como textura.
// #declare TPEA_DefaultTexturaBannerLateral         
//      Logo lateral como textura.
// #declare TPEA_DefaultTexturaMetalica         
//      Textura del cable.
// #declare TPEA_DefaultTexturaAuricular         
//      Textura del auricular.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare TPEA_TexturaCasetilla               = texture { ... }        
//      Textura principal de la casetilla.
// #declare TPEA_TexturaTelefono                = texture { ... }
//      Textura del aparato telefonico.
// #declare TPEA_TexturaBannerFrontal           = texture { ... }
//      Logo frontal como textura.
// #declare TPEA_TexturaBannerLateral           = texture { ... }         
//      Logo lateral como textura.
// #declare TPEA_TexturaMetalica                = texture { ... }         
//      Textura del cable.
// #declare TPEA_TexturaAuricular               = texture { ... }        
//      Textura del auricular.
// #declare TPEA_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "TPEA.inc"
// object        { TPEA_Telefono( 1000 ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "TPEA.inc"   
// object                       {
//    TPEA_TelefonoPublicoExpuestoAire( 1000, 1.215, 0.740, 0.440, 
//              0.318, 0.146, 0.260, 0.190, 0.160, 0.165, 0.044, 0.002, 0.010,         
//              TPEA_TexturaCasetilla, TPEA_TexturaTelefono,
//              TPEA_TexturaBannerFrontal, TPEA_TexturaBannerLateral,
//              TPEA_TexturaMetalica, TPEA_TexturaAuricular )
// }
//        
// Con modificadores
// #include "TPEA.inc"
// #include "textures.inc"
// #declare TPEA_TexturaCasetilla       = PinkAlabaster
// object        { TPEA_Telefono( 1000 ) }
// 
#include "textures.inc" 
#include "stones.inc"
#include "colors.inc"
#include "TPEA_AU1.inc"

#declare TPEA_L                 = 0.001; 

#if ( version < 3.2 )
  #ifndef( TPEA_POV3_1 )
    #declare TPEA_POV3_1        = on;
  #end
#else
  #ifndef( TPEA_POV3_1 )
    #declare TPEA_POV3_1        = off;
  #end
#end
  
#declare TPEA_DefaultTexturaCasetilla   =
  texture                               {
    Chrome_Texture    
    normal                              {
      waves
      turbulence                1
    }
  }

#ifndef ( TPEA_TexturaCasetilla )
  #declare TPEA_TexturaCasetilla        = TPEA_DefaultTexturaCasetilla
#end  // #ifndef( TPEA_TexturaCasetilla )

#declare TPEA_DefaultTexturaTelefono    =
  texture                               {
    T_Stone41           
    normal              {
      granite scale 0.01    
    }
  }

#ifndef ( TPEA_TexturaTelefono )
  #declare TPEA_TexturaTelefono         = TPEA_DefaultTexturaTelefono
#end  // #ifndef( TPEA_TexturaTelefono )

#declare TPEA_DefaultTexturaBannerFrontal       =
  texture                               {
    pigment                             {
      image_map                       {
        gif "TPEA_IM1.gif"
      }
      translate         -0.5
      scale             <1,2,1>
    }
    normal                              {
      waves
      turbulence                1
    }
  }

#ifndef ( TPEA_TexturaBannerFrontal )
  #declare TPEA_TexturaBannerFrontal    = TPEA_DefaultTexturaBannerFrontal
#end  // #ifndef( TPEA_TexturaBannerFrontal )

#declare TPEA_DefaultTexturaBannerLateral       =
  texture                               {
    pigment                             {
      image_map                       {
        gif "TPEA_IM2.gif"
      }
      translate         -0.5
      scale             2
    }
    normal                              {
      waves
      turbulence                1
    }
  }

#ifndef ( TPEA_TexturaBannerLateral )
  #declare TPEA_TexturaBannerLateral    = TPEA_DefaultTexturaBannerLateral
#end  // #ifndef( TPEA_TexturaBannerLateral )

#declare TPEA_DefaultTexturaMetalica    =
  texture                               {
    Brass_Texture   
    normal                              {
      gradient y triangle_wave scale 0.005
    }
  }

#ifndef ( TPEA_TexturaMetalica )
  #declare TPEA_TexturaMetalica         = TPEA_DefaultTexturaMetalica
#end  // #ifndef( TPEA_TexturaMetalica )

#declare TPEA_DefaultTexturaAuricular   =
  texture                               {
    pigment { Gray20 } 
    normal                              {   
      agate
    }
  }

#ifndef ( TPEA_TexturaAuricular )
  #declare TPEA_TexturaAuricular        = TPEA_DefaultTexturaAuricular
#end  // #ifndef( TPEA_TexturaAuricular )

#macro TPEA_TelefonoPublicoExpuestoAire( SeedCable, AltoTotal,
                AltoCasetilla, AnchoCasetilla, ProfundidadCasetilla,
                AltoBanner, AltoTelefono, AnchoTelefono, ProfundidadTelefono,
                AltoAuricular, GruesoAuricular, GruesoMetal, GruesoDecorativo,
                TexturaCasetilla, TexturaTelefono, TexturaBannerFrontal,
                TexturaBannerLateral, TexturaMetalica, TexturaAuricular )
  union                                 { 
    #local BanderaAuricular             = ( SeedCable >= 0 );   
    #local S                            = seed( SeedCable );
    #local AnchoPoste                   = 179/440*AnchoCasetilla;
    #local ProfundidadPoste             =  69/318*ProfundidadCasetilla;
    #local AltoPoste                    = AltoTotal-0.1*AltoCasetilla;
    union                               {
      box                               {
        < -    AnchoPoste/2,         0, 0 >,
        < -0.9*AnchoPoste/2, AltoPoste, ProfundidadPoste >
      }
      box                               {
        < +    AnchoPoste/2,         0, 0 >,
        < +0.9*AnchoPoste/2, AltoPoste, ProfundidadPoste >
      }
      box                               {
        < +    AnchoPoste/2,         0, 0.10*ProfundidadPoste >,
        < -    AnchoPoste/2, AltoPoste, 0.20*ProfundidadPoste >
      }
      box                               {
        < +    AnchoPoste,         0, -ProfundidadPoste >,
        < -    AnchoPoste, 0.05*( AltoTotal-AltoCasetilla ), +ProfundidadPoste >
      }
      texture                           {
        TexturaCasetilla
      }
    }
    // banner
    difference                          {
      union                             {
        box                               {
          < -AnchoCasetilla/2, 0, 0 >,
          < +AnchoCasetilla/2, 0.99*AltoBanner, -ProfundidadCasetilla >
          texture                         {
            TexturaTelefono
          }
        }
        box                             {
          < -AnchoCasetilla/2+GruesoMetal, 0, GruesoMetal >,
          < +AnchoCasetilla/2-GruesoMetal, AltoBanner,
            -ProfundidadCasetilla+GruesoMetal >
        }
      }
      box                               {
        -1, 1
        texture                         {
          TexturaBannerFrontal
        }
        scale           < AnchoCasetilla, 0.3*AltoBanner, 2*GruesoMetal >
        translate                       0.5*AltoBanner*y
        translate                       -ProfundidadCasetilla*z
      }
      box                               {
        -1, 1
        texture                         {
          TexturaBannerLateral
        }
        rotate                          +90*y
        scale           < 2*GruesoMetal, 0.3*AltoBanner, 0.4*ProfundidadCasetilla >
        translate                       0.5*AltoBanner*y-0.5*AnchoCasetilla*x
        translate                       -0.6*ProfundidadCasetilla*z
      }
      box                               {
        -1, 1
        texture                         {
          TexturaBannerLateral
        }
        rotate                          -90*y
        scale           < 2*GruesoMetal, 0.3*AltoBanner, 0.4*ProfundidadCasetilla >
        translate                       0.5*AltoBanner*y+0.5*AnchoCasetilla*x
        translate                       -0.6*ProfundidadCasetilla*z
      }
      texture                           {
        TexturaCasetilla
      }
      translate                         ( AltoTotal-AltoBanner )*y
    }
    // Casetilla
    union                               {
      difference                        {
        prism                           {
          -0.48*AnchoCasetilla, +0.48*AnchoCasetilla,
          4,
          < 0, 0 >,
          < +AltoCasetilla-AltoBanner, 0 >,
          < +AltoCasetilla-AltoBanner, -0.96*ProfundidadCasetilla >,
          < 0, -0.8*ProfundidadCasetilla >
          rotate                        90*z
        }
        box                             {
          < -0.48*AnchoCasetilla+GruesoMetal, 10*GruesoMetal,
            -GruesoMetal >,
          < +0.48*AnchoCasetilla-GruesoMetal, AltoCasetilla-AltoBanner,
            -ProfundidadCasetilla >
        }
        #local C                        = 0;
        #while ( C < 20 )
          cylinder                      {
            -AnchoCasetilla*x, +AnchoCasetilla*x, GruesoDecorativo/2
            translate                   +5*GruesoDecorativo*z
            rotate                      C*360*x/20
            translate                   +AltoCasetilla/2*y
                                        -ProfundidadCasetilla/2*z
          }
          #local C                      = C+1;
        #end  // #while ( C < 1 )
      }
      cylinder                          {
        0, ( AltoCasetilla-AltoBanner )*y, GruesoMetal
        translate                       -GruesoMetal*z
                                -( AnchoTelefono/2+GruesoMetal )*x
      }
      cylinder                          {
        0, ( AltoCasetilla-AltoBanner )*y, GruesoMetal
        translate                       -GruesoMetal*z
                                +( AnchoTelefono/2+GruesoMetal )*x
      }
      cylinder                          {
        0, -ProfundidadCasetilla*z, GruesoMetal
        translate                       -GruesoMetal*z
                                -( AnchoTelefono/2+GruesoMetal )*x
                                +( AltoCasetilla-AltoBanner )*y
      }
      cylinder                          {
        0, -ProfundidadCasetilla*z, GruesoMetal
        translate                       -GruesoMetal*z
                                +( AnchoTelefono/2+GruesoMetal )*x
                                +( AltoCasetilla-AltoBanner )*y
      }
      // Telefono
      union                             {
        // Teclado superpuesto
        union                           {
          difference                    {
            box                         {
              < -0.20,  0.20, 0 >,
              <  0.70,  0.95, -0.01 >
            }
            box                         {
              < -0.10,  0.825, -0.0025 >,
              <  0.60,  0.925, -0.011 >
            }
            rotate              10*x
            translate           +0.8*y-z
          }
          box                         {
            < -0.10,  0.825, 0.002 >,
            <  0.60,  0.925, -0.01025 >
            pigment { Green transmit 0.6 }
            rotate              10*x
            translate           +0.8*y-z
          }
          union                         {
            union                       {
              #local C                  = 0;
              #while ( C < 4 )
                cylinder                      {
                  0, -0.015*z, 0.05
                  translate             -0.15*C*y+0.45*x
                }
                cylinder                      {
                  0, -0.025*z, 0.03
                  translate             -0.15*C*y+0.45*x
                }
                #local C                = C+1;
              #end  // #while ( C < 4 )
              translate           0.75*y
              rotate              10*x
              translate           +0.8*y-z
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "1", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y
                pigment { Gray20 }
              }
              translate           0.75*y
              rotate              10*x
              translate           +0.8*y-z
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "2", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.75*y
              rotate              10*x
              translate           +0.8*y-z+0.15*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "3", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.75*y
              rotate              10*x
              translate           +0.8*y-z+0.30*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "4", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.60*y
              rotate              10*x
              translate           +0.8*y-z
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "5", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.60*y
              rotate              10*x
              translate           +0.8*y-z+0.15*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "6", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.60*y
              rotate              10*x
              translate           +0.8*y-z+0.30*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "7", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.45*y
              rotate              10*x
              translate           +0.8*y-z
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "8", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.45*y
              rotate              10*x
              translate           +0.8*y-z+0.15*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "9", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.45*y
              rotate              10*x
              translate           +0.8*y-z+0.30*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "#", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.30*y
              rotate              10*x
              translate           +0.8*y-z
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "0", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.30*y
              rotate              10*x
              translate           +0.8*y-z+0.15*x
            }
            union                         {
              cylinder                      {
                0, -0.025*z, 0.05
              }
              text                        {
                ttf "timrom.ttf", "*", 1, 0
                scale             0.050
                translate         -0.030*z-0.020*y-0.005*x
                pigment { Gray20 }
              }
              translate           0.30*y
              rotate              10*x
              translate           +0.8*y-z+0.30*x
            }
          }
          box                           {
            < -0.20,  0, 0 >,
            <  0.70,  0.1, -0.01 >
            rotate              10*x
            translate           +0.8*y-z
          }
          texture                       {
            TexturaCasetilla
          }
          translate                     0.15*x
          scale                       < AnchoTelefono/2, AltoTelefono/2, ProfundidadTelefono >
        }
        difference                      {
          union                         {
            superellipsoid                {
              < 0.1, 0.4 >
              rotate                      90*y
              rotate                      90*z
              translate                   y
            }
            superellipsoid                {
              < 0.1, 0.6 >
              rotate                      90*y
              rotate                      90*z
              scale                       <0.4,0.3,0.2>
              translate                   0.3*y-0.9*z+0.2*x
            }
          }
          box                           {
            < 0.00, +0.10, +0.2 >,
            < 0.40, +0.20, -1 >
            translate           +0.0*y-z
          }
          box                           {
            < 0.10, +0.10, +0.1 >,
            < 0.20, +0.50, -1 >
            translate           +0.0*y-z
          }
          cylinder                      {
            0.0, 0.4*x, 0.10
            translate           0.30*y-1.0*z
          }
          box                           {
            < -0.3, -1, 0 >,
            < 0.80, +1, -1 >
            rotate              10*x
            translate           +0.8*y-z
          }
          plane                         {
            -z, 0
          }
          union                         {
            cylinder                    {
              0, +1*GruesoAuricular*z/ProfundidadTelefono, 0.60*GruesoAuricular/AnchoTelefono
              translate                  ( AltoAuricular-GruesoAuricular/2 )*y/AltoTelefono
              translate                 -z-( 0.6 )*x+1.10*y
            }
            cylinder                    {
              0, +1*GruesoAuricular*z/ProfundidadTelefono, 0.60*GruesoAuricular/AnchoTelefono
              translate                -( AltoAuricular-GruesoAuricular/2 )*y/AltoTelefono
              translate                 -z-( 0.6 )*x+1.10*y
            }
            box                         {
              < -0.9, 1.8, 0 >,
              < -0.3, 0.4, +GruesoAuricular/ProfundidadTelefono*0.5 >
              translate                 -z
            }
          }
          
          scale                       < AnchoTelefono/2, AltoTelefono/2, ProfundidadTelefono >
        }
        // Monedero
        difference                      {
          superellipsoid                {
            < 0.1, 0.1 >
            scale                       <0.4,0.2,0.1>
            translate                   2*y+0.2*x
          }
          plane                         {
            -z, 0
          }
          cylinder                      {
            -0.05*z, -z
            0.075
            translate                   2.1*y+0.3*x
            texture { TexturaMetalica }
          }
          scale                       < AnchoTelefono/2, AltoTelefono/2, ProfundidadTelefono >
        }
        texture                         {
          TexturaTelefono
        }
        translate                       +( AltoCasetilla
                        -AltoBanner-1.2*AltoTelefono )*y-GruesoMetal*z
      }
      // Auricular 
      #if ( BanderaAuricular ) 
        intersection                      {
          #local Curvatura                = 0.5;
          difference                      {
            union                         {
              lathe                           {
                cubic_spline
                6,
                < +Curvatura, -0.8*GruesoAuricular/2 >,
                < +Curvatura,  0.8*GruesoAuricular/2 >,
                < +Curvatura+0.75*GruesoAuricular, 0 >,
                < +Curvatura, -0.8*GruesoAuricular/2 >,
                < +Curvatura,  0.8*GruesoAuricular/2 >,
                < +Curvatura+0.75*GruesoAuricular, 0 >
                rotate                      90*x
                translate                   +( Curvatura-GruesoAuricular/2 )*x
              }
              cylinder                    {
                0, -GruesoAuricular*x/2, GruesoAuricular/2
                translate                 ( AltoAuricular-GruesoAuricular )*y/2
              }
              cylinder                    {
                0, -GruesoAuricular*x/2, GruesoAuricular/2
                translate                 -( AltoAuricular-GruesoAuricular )*y/2
              }
            }
            plane                         {
              -x, 0
            }
            plane                         {
              -y, -AltoAuricular/2
            }
            plane                         {
              +y, -AltoAuricular/2
            }
            rotate                        -90*y
          }
          cylinder                        {
            -10*GruesoAuricular*z, +10*GruesoAuricular*z, AltoAuricular/2
            scale  <0.5,1,1>
          }
          translate                       ( AltoCasetilla-AltoBanner
                        -0.65*AltoTelefono )*y-ProfundidadTelefono*z
                        -0.3*AnchoTelefono*x 
          #declare Vibracion              = 2*0.5*AnchoTelefono;                
          #declare ArregloAuricular       = array [5]
            { < -0.3*AnchoTelefono, AltoCasetilla-AltoBanner-0.95*AltoTelefono,
                -ProfundidadTelefono-GruesoAuricular >,
              < -0.0*AnchoTelefono, 0.25*AltoCasetilla,
                -0.8*ProfundidadTelefono >+Vibracion*(< rand(S),rand(S),rand(S)>-0.5),
              < -0.2*AnchoTelefono, 0.05*AltoCasetilla,
                -ProfundidadTelefono >+Vibracion*(< rand(S),rand(S),rand(S)>-0.5),
              < -0.4*AnchoTelefono, 0.25*AltoCasetilla,
                -1.1*ProfundidadTelefono >+Vibracion*(< rand(S),rand(S),rand(S)>-0.5),
              < -0.1*AnchoTelefono, AltoCasetilla-AltoBanner-1.2*AltoTelefono,
                -ProfundidadTelefono+GruesoAuricular > }
          texture                         {
            TexturaAuricular
          }
        }  
      
        object                          {
          TPEA_SweepBezierAbierto( ArregloAuricular, 0.075*GruesoAuricular, 1 )
          texture { TexturaMetalica  }
        }
      #end  // #if ( BanderaAuricular )
      
      texture                           {
        TexturaCasetilla
      }
      translate                         ( AltoTotal-AltoCasetilla )*y
    }
  }
#end  // TPEA_TelefonoVigiladoPorCamara


#macro TPEA_Telefono( SeedCable )
  object                                {
    #local L                            = TPEA_L;  
    #local AltoTotal                    = 1215*L;
    #local AltoCasetilla                =  740*L;
    #local AnchoCasetilla               =  440*L;
    #local ProfundidadCasetilla         =  318*L;
    #local AltoBanner                   =  146*L;
    #local AltoTelefono                 =  260*L;
    #local AnchoTelefono                =  190*L;
    #local ProfundidadTelefono          =  160*L;
    #local AltoAuricular                =  165*L;
    #local GruesoAuricular              =   44*L;
    #local GruesoMetal                  =    2*L;
    #local GruesoDecorativo             =   10*L;
    TPEA_TelefonoPublicoExpuestoAire( SeedCable, AltoTotal,
         AltoCasetilla, AnchoCasetilla, ProfundidadCasetilla,
         AltoBanner, AltoTelefono, AnchoTelefono, ProfundidadTelefono,
         AltoAuricular, GruesoAuricular, GruesoMetal, GruesoDecorativo,
         TPEA_TexturaCasetilla, TPEA_TexturaTelefono,
         TPEA_TexturaBannerFrontal, TPEA_TexturaBannerLateral,
         TPEA_TexturaMetalica, TPEA_TexturaAuricular )
  }
#end  // #macro


