// This file is licensed under the terms of the CC-LGPL.
//
// Autor  : Rafael Angel Campos Vargas
// Correo : RofoelCompos@hotmail.com  
// Apdo. 964-1250 Escazu, San Jose, Costa Rica
// dedicado a Jesus y Maria...
//
// En este momento estoy creando un programa
// de animacion LibreN3D para FreeDOS con el compilador FreePascal
// falta mucho... 21 julio 2015
//                
// Mis dibujos estan en unidades L (Lisa)
// 1 L equivale a 0.055063 pulgadas 
// definido como 0.001 para POVRAY
//     
// TPEA TelefonoPublicoExpuestoAire
// El archivo dibuja un Telefono Publico tipico en Costa Rica.
// Es muy poco flexible, pero incluye una macro para modificar 
// algunas de sus caracteristicas principales.
// Es compatible con POVRay 3.1.
//
// La macro principal tiene unicamente un parametro. 
// #macro TPEA_Telefono( SeedCable )
//      SeedCable               : Inicia el generador de numeros aleatorios,
//              para modificar al azar la posicion del cable. Utilice,
//              valores negativos para no dibujar ni el cable ni el auricular.
//
// La siguiente macro permite un mayor control de las caracteristicas.
// #macro TPEA_TelefonoPublicoExpuestoAire( SeedCable, AltoTotal,
//              AltoCasetilla, AnchoCasetilla, ProfundidadCasetilla,
//              AltoBanner, AltoTelefono, AnchoTelefono, ProfundidadTelefono,
//              AltoAuricular, GruesoAuricular, GruesoMetal, GruesoDecorativo,
//              TexturaCasetilla, TexturaTelefono, TexturaBannerFrontal,
//              TexturaBannerLateral, TexturaMetalica, TexturaAuricular )
//      SeedCable               : Inicia el generador de numeros aleatorios,
//              para modificar al azar la posicion del cable. Utilice,
//              valores negativos para no dibujar ni el cable ni el auricular. 
//      AltoTotal               : Alto total del aparato.
//              Valor por defecto 1215*L.
//      AltoCasetilla           : Alto de la casetilla que protege al telefono.
//              Valor por defecto 740*L.
//      AnchoCasetilla          : Ancho frontal de la casetilla que protege 
//              al telefono. Valor por defecto 440*L.
//      ProfundidadCasetilla    : Profundidad lateral de la casetilla. Valor por
//              defecto 318*L.
//      AltoBanner              : Alto de la franja superior de la casetilla.
//              Valor por defecto 146*L.
//      AltoTelefono            : Referencia para el alto del telefono.
//              Valor por defecto 260*L.
//      AnchoTelefono           : Ancho del telefono.
//              Valor por defecto 190*L.
//      ProfundidadTelefono     : Profundidad del telefono.  
//              Valor por defecto 160*L.
//      AltoAuricular           : Alto del auricular.
//              Valor por defecto 165*L.
//      GruesoAuricular         : Grueso del auricular.
//              Valor por defecto 44*L.
//      GruesoMetal             : Grueso de la placa metalica.
//              Valor por defecto 2*L.
//      GruesoDecorativo        : Grueso de perforaciones a placa metalica,
//              que sirven para incrementar la exposicion al aire.
//              Valor por defecto 10*L.
//      TexturaCasetilla        : Textura principal de la casetilla.
//              Valor por defecto TPEA_TexturaCasetilla.
//      TexturaTelefono         : Textura del aparato telefonico.
//              Valor por defecto TPEA_TexturaTelefono.
//      TexturaBannerFrontal    : Logo frontal como textura. 
//              Valor por defecto TPEA_TexturaBannerFrontal.
//      TexturaBannerLateral    : Logo lateral como textura.
//              Valor por defecto TPEA_TexturaBannerLateral.
//      TexturaMetalica         : Textura del cable. 
//              Valor por defecto TPEA_TexturaMetalica.
//      TexturaAuricular        : Textura del auricular.
//              Valor por defecto TPEA_TexturaAuricular.
//
// El telefono publico
// se encuentra completamente contenido en las siguientes coordenadas.
//      Minimo  = < -220,    0,  -370 >*L
//      Maximo  = <  220, 1215,    80 >*L 
// La casetilla sobresale del plano XZ, con frente que mira hacia Z-.
// El poste se sumerge en Z+. De tal forma que el plano XZ separa el poste y la 
// casetilla. Gravedad Y-. 
//
// Estas son variables predefinidas o generadas en el
// interior de las macros que no deberian modificarse directamente.
// Si quiere cambiarlas, recurra a los modificadores.  
// #declare TPEA_DefaultTexturaCasetilla        
//      Textura principal de la casetilla.
// #declare TPEA_DefaultTexturaTelefono            
//      Textura del aparato telefonico.
// #declare TPEA_DefaultTexturaBannerFrontal        
//      Logo frontal como textura.
// #declare TPEA_DefaultTexturaBannerLateral         
//      Logo lateral como textura.
// #declare TPEA_DefaultTexturaMetalica         
//      Textura del cable.
// #declare TPEA_DefaultTexturaAuricular         
//      Textura del auricular.
//
// Los siguientes son los modificadores
// aplicables y redefinibles por el usuario (si se indica es default)   
// #declare TPEA_TexturaCasetilla               = texture { ... }        
//      Textura principal de la casetilla.
// #declare TPEA_TexturaTelefono                = texture { ... }
//      Textura del aparato telefonico.
// #declare TPEA_TexturaBannerFrontal           = texture { ... }
//      Logo frontal como textura.
// #declare TPEA_TexturaBannerLateral           = texture { ... }         
//      Logo lateral como textura.
// #declare TPEA_TexturaMetalica                = texture { ... }         
//      Textura del cable.
// #declare TPEA_TexturaAuricular               = texture { ... }        
//      Textura del auricular.
// #declare TPEA_POV3_1                         = off;
//      Valor on activa modo de compatibilidad con POVRay 3.1.
//      En algunas versiones se activara automaticamente.
//
// Para colocarlo simplemente
// #include "TPEA.inc"
// object        { TPEA_Telefono( 1000 ) }
//                                 , 
// Ejemplo con la macro detallada, mismo objeto default
// #include "TPEA.inc"   
// object                       {
//    TPEA_TelefonoPublicoExpuestoAire( 1000, 1.215, 0.740, 0.440, 
//              0.318, 0.146, 0.260, 0.190, 0.160, 0.165, 0.044, 0.002, 0.010,         
//              TPEA_TexturaCasetilla, TPEA_TexturaTelefono,
//              TPEA_TexturaBannerFrontal, TPEA_TexturaBannerLateral,
//              TPEA_TexturaMetalica, TPEA_TexturaAuricular )
// }
//        
// Con modificadores
// #include "TPEA.inc"
// #include "textures.inc"
// #declare TPEA_TexturaCasetilla       = PinkAlabaster
// object        { TPEA_Telefono( 1000 ) }
// 
#include "colors.inc"

#declare OjoAbsoluto            = 256;
#declare VecesCentroAbsoluto    = 10;     
#declare L                      = 0.001;
camera {
        location  <   0,  0, -( VecesCentroAbsoluto+1 )*OjoAbsoluto >*L
        direction z
        sky       y
        angle     38.74
//        look_at  <   0,  0, -VecesCentroAbsoluto*OjoAbsoluto >*L
}         
light_source    {
         < 500  , 500   , -3000 >*L
         White
}
background      {
         Gray50
}    

#include "TPEA.inc"
 

object                  {
  TPEA_Telefono( 1000 )
  translate             -0.60*y
} 


 





